program _Cervik_;
{$r ervk.res}
uses
  winprocs, owindows, wintypes, strings, mmsystem;

const
  inifile = 'Cervik.ini';
  obj_empty  = 0;
  obj_body   = 1;
  obj_headup = 2;
  obj_headl  = 3;
  obj_headdn = 4;
  obj_headr  = 5;
  obj_poison = 6;
  obj_meal   = 7;
  obj_flag   = 8;
  obj_wall   = 9;
  st_intro   = 10;
  st_game    = 11;
  st_pause   = 12;
  st_enter   = 13;

type
  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

  pcerwindow = ^tcerwindow;
  tcerwindow = object(twindow)
    uvod, o1, o2, o3, o4, o5, o6, o7, o8, o9, o10,
    t1, t2, t3, t4, t5                            : hbitmap;
    pocitadlo, score, oldx, oldy, newx, newy, stsc: integer;
    klav                                          : word;
    pause, ltlac, rtlac, boolex, konhry, jevlajka,
    dalsil                                        : boolean;
    cerfont                                       : tlogfont;
    thefont                                       : hfont;
    hracipole                                     : array[0..19, 0..14] of byte;
    stav, level, smer, delka, citac               : byte;
    cerv                                          : array[0..255] of record
                                                                      pozx, pozy  : integer;
                                                                      umx, umy, sm: byte;
                                                                    end;
    strvstup                                      : array[0..7] of char;
    constructor init(aparent: pwindowsobject; title: pchar);
    function canclose: boolean; virtual;
    function inside(x1, y1, x2, y2, x, y: integer): boolean;
    procedure nakresliBMP(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(paintdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure drawex(dc: hdc; jak: boolean);
    procedure drawuvod(dc: hdc);
    procedure drawpole(dc: hdc);
    procedure drawvstup(dc: hdc);
    procedure showbrd(dc: hdc);
    procedure hidebrd(dc: hdc);
    procedure novahra;
    procedure hra;
    procedure konechry(jaky: boolean);
    procedure setupwindow; virtual;
    procedure vytvorfont(var afont: hfont);
    procedure wmdestroy(var msg: tmessage); virtual wm_destroy;
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown + wm_first;
    procedure wmlbuttonup(var msg: tmessage); virtual wm_lbuttonup + wm_first;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown + wm_first;
    procedure wmrbuttonup(var msg: tmessage); virtual wm_rbuttonup + wm_first;
    procedure wmmousemove(var msg: tmessage); virtual wm_mousemove + wm_first;
    procedure wmkeydown(var msg: tmessage); virtual wm_keydown + wm_first;
    procedure wmkeyup(var msg: tmessage); virtual wm_keyup + wm_first;
    procedure wmtimer(var msg: tmessage); virtual wm_timer + wm_first;
    procedure wmsize(var msg: tmessage); virtual wm_size + wm_first;
  end;

  skor = record
           jmeno: array[0..8] of char;
           body : integer;
         end;

var
  skore              : skor;
  zvuky, oknox, oknoy: integer;

procedure nactiprofil; forward;
procedure zapisprofil; forward;

constructor tcerwindow.init(aparent: pwindowsobject; title: pchar);
begin
  twindow.init(aparent, title);
  attr.x := oknox;
  attr.y := oknoy;
  attr.w := 640;
  attr.h := 490;
  attr.style := ws_popup;
  randomize;
  thefont := 0;
end;

function tcerwindow.canclose: boolean;
begin
  if messagebox(hwindow, 'Opravdu chcete program ervk ukonit?', 'ervk', mb_YesNo or mb_IconQuestion) = id_Yes then
    canclose := true else canclose := false;
end;

function tcerwindow.inside(x1, y1, x2, y2, x, y: integer): boolean;
begin
  inside := (x1 <= x) and (y1 <= y) and (x2 >= x) and (y2 >= y);
end;

procedure tcerwindow.nakresliBMP(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(uvod, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tcerwindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  wndclass.style := 0;
  wndclass.hbrbackground := getstockobject(black_brush);
  wndclass.hicon := loadicon(hinstance, 'IKONA');
end;

procedure tcerwindow.paint(paintdc: hdc; var paintinfo: tpaintstruct);
var
  i, j: integer;
begin
  j := attr.w div 10 - 1;
  for i := 1 to j do nakresliBMP(paintdc, i*10, 0, t1);
  nakresliBMP(paintdc, 0, 0, t2);
  nakresliBMP(paintdc, attr.w-10, 0, t3);
  nakresliBMP(paintdc, attr.w-20, 0, t4);
  case stav of
    st_intro: drawuvod(paintdc);
    st_game : drawpole(paintdc);
    st_pause: drawpole(paintdc);
    st_enter: drawvstup(paintdc);
  end;
end;

procedure tcerwindow.drawex(dc: hdc; jak: boolean);
begin
  if jak then nakresliBMP(dc, attr.w-20, 0, t5)
  else nakresliBMP(dc, attr.w-20, 0, t4);
end;

procedure tcerwindow.drawuvod(dc: hdc);
var
  madedc: boolean;
  strcis: array[0..7] of char;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  nakresliBMP(dc, 160, 50, uvod);
  selectobject(dc, thefont);
  setbkmode(dc, transparent);
  settextcolor(dc, rgb(255, 160, 0));
  settextalign(dc, ta_left);
  textout(dc, 160, 300, 'Nejlep skre:', 15);
  textout(dc, 160, 330, skore.jmeno, strlen(skore.jmeno));
  textout(dc, 5, 430, 'http://', 7);
  textout(dc, 300, 430, 'e-mail:', 7);
  settextalign(dc, ta_right);
  str(skore.body, strcis);
  textout(dc, 480, 330, strcis, strlen(strcis));
  settextalign(dc, ta_center);
  textout(dc, 320, 400, 'Stiskem klvesy [Enter] spustte hru...', 39);
  settextcolor(dc, rgb(30, 30, 230));
  settextalign(dc, ta_left);
  textout(dc, 85, 430, 'hamsoft.wz.cz/', 14);
  textout(dc, 380, 430, 'louzeckyfilip@seznam.cz', 23);
  textout(dc, 380, 460, 'ham_soft@volny.cz', 17);
  if madedc then releasedc(hwindow, dc);
end;

procedure tcerwindow.drawpole(dc: hdc);
var
  i, j: byte;
begin
  for j := 0 to 14 do
    for i := 0 to 19 do
      case hracipole[i, j] of
        obj_empty : nakresliBMP(dc, i*32, j*32+10, o1);
        obj_body  : nakresliBMP(dc, i*32, j*32+10, o2);
        obj_headup: nakresliBMP(dc, i*32, j*32+10, o3);
        obj_headl : nakresliBMP(dc, i*32, j*32+10, o4);
        obj_headdn: nakresliBMP(dc, i*32, j*32+10, o5);
        obj_headr : nakresliBMP(dc, i*32, j*32+10, o6);
        obj_poison: nakresliBMP(dc, i*32, j*32+10, o7);
        obj_meal  : nakresliBMP(dc, i*32, j*32+10, o8);
        obj_flag  : nakresliBMP(dc, i*32, j*32+10, o9);
        obj_wall  : nakresliBMP(dc, i*32, j*32+10, o10);
      end;
  showbrd(dc);
end;

procedure tcerwindow.drawvstup(dc: hdc);
var
  madedc: boolean;
  i     : byte;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  selectobject(dc, thefont);
  setbkmode(dc, transparent);
  settextalign(dc, ta_left);
  settextcolor(dc, rgb(255, 160, 0));
  textout(dc, 50, 100, 'Blahopeji, doshl jsi nejvyho skre!', 40);
  textout(dc, 50, 150, 'Tv jmno:', 10);
  for i := 0 to 7 do nakresliBMP(dc, 180+i*32, 150, o1);
  textout(dc, 180, 150, strvstup, strlen(strvstup));
  if madedc then releasedc(hwindow, dc);
end;

procedure tcerwindow.showbrd(dc: hdc);
var
  madedc: boolean;
  textik: array[0..7] of char;
  i     : byte;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  selectobject(dc, thefont);
  setbkmode(dc, transparent);
  settextalign(dc, ta_left);
  settextcolor(dc, rgb(255, 160, 0));
  textout(dc, 5, 11, 'Level:', 6);
  str(level, textik);
  textout(dc, 70, 11, textik, strlen(textik));
  textout(dc, 130, 11, 'Skre:', 6);
  str(score, textik);
  textout(dc, 207, 11, textik, strlen(textik));
  if madedc then releasedc(hwindow, dc);
end;

procedure tcerwindow.hidebrd(dc: hdc);
var
  i: byte;
begin
  for i := 0 to 8 do nakresliBMP(dc, i*32, 10, o10);
end;

procedure tcerwindow.novahra;
 function prirad(co: byte): byte;
 begin
   case co of
     obj_empty : prirad := obj_empty;
     obj_body  : prirad := obj_empty;
     obj_headup: prirad := obj_headup;
     obj_headl : prirad := obj_headl;
     obj_headdn: prirad := obj_headdn;
     obj_headr : prirad := obj_headr;
     obj_poison: prirad := obj_poison;
     obj_meal  : prirad := obj_meal;
     obj_flag  : prirad := obj_empty;
     obj_wall  : prirad := obj_wall;
   end;
 end;
var
  i, j, k, cl: byte;
begin
  for i := 0 to 19 do
  begin
    hracipole[i, 0] := obj_wall;
    hracipole[i, 14] := obj_wall;
  end;
  for j := 0 to 14 do
  begin
    hracipole[0, j] := obj_wall;
    hracipole[19, j] := obj_wall;
  end;
  stsc := score;
  jevlajka := false;
  dalsil := false;
  delka := 1;
  smer := 0;
  cl := 0;
  konhry := false;
  stav := st_game;
  if level = 255 then konhry := true;
  inc(level);
  for j := 1 to 13 do
    for i := 1 to 18 do
    begin
      nakresliBMP(0, i*32, j*32+10, o1);
      case level of
        1..2    : begin
                    k := random(50);
                    if k in [0..39] then hracipole[i, j] := obj_empty
                    else k := k - 40;
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
        3..6    : begin
                    k := random(40);
                    if k in [0..29] then hracipole[i, j] := obj_empty
                    else k := k - 30;
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
        7..14   : begin
                    k := random(30);
                    if k in [0..19] then hracipole[i, j] := obj_empty
                    else k := k - 20;
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
        15..30  : begin
                    k := random(20);
                    if k in [0..9] then hracipole[i, j] := obj_empty
                    else k := k - 10;
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
        31..62  : begin
                    k := random(14);
                    if k in [0..3] then hracipole[i, j] := obj_empty
                    else k := k - 4;
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
        63..126 : begin
                    k := random(12);
                    if k in [0..1] then hracipole[i, j] := obj_empty
                    else k := k - 2;
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
        127..255: begin
                    k := random(10);
                    k := prirad(k);
                    if (k = obj_headup) or (k = obj_headl) or (k = obj_headdn) or (k = obj_headr) then
                    begin
                      if cl = 0 then
                      begin
                        cl := 1;
                        hracipole[i, j] := k;
                        cerv[1].umx := i;
                        cerv[1].umy := j;
                      end
                      else hracipole[i, j] := obj_meal;
                    end
                    else hracipole[i, j] := k;
                  end;
      end;
    end;
  if konhry then konechry(true)
  else
  begin
    cerv[1].sm := 0;
    drawpole(0);
    showbrd(0);
    hra;
  end;
end;

procedure tcerwindow.hra;
 procedure vlajka;
 var
   i, j: byte;
 begin
   if ((score - stsc) > 50) and not jevlajka then
   begin
     for j := 13 downto 1 do
       for i := 18 downto 1 do
         if (hracipole[i, j] = obj_empty) and not jevlajka then
         begin
           hracipole[i, j] := obj_flag;
           nakresliBMP(0, i*32, j*32+10, o9);
           jevlajka := true;
         end;
   end;
 end;
 procedure zahraj;
 var
   pom: byte;
 begin
   pom := random(5);
   case pom of
     0: begin sndplaysound('click1.wav', 1); score := score + 1; end;
     1: begin sndplaysound('click2.wav', 1); score := score + 2; end;
     2: begin sndplaysound('plop1.wav', 1); score := score + 3; end;
     3: begin sndplaysound('plop2.wav', 1); score := score + 4; end;
     4: begin sndplaysound('tlik.wav', 1); score := score + 5; end;
   end;
   hidebrd(0);
   showbrd(0);
   vlajka;
 end;
 procedure posun;
 var
   i, j: byte;
 begin
   for i := delka downto 1 do
     if i = 1 then
     begin
       case smer of
         1: begin
              if (hracipole[cerv[1].umx-1, cerv[1].umy] = obj_wall) or
                (hracipole[cerv[1].umx-1, cerv[1].umy] = obj_poison) or
                (hracipole[cerv[1].umx-1, cerv[1].umy] = obj_body) then
              begin
                sndplaysound('poison.wav', 1);
                konhry := true;
              end;
              if delka = 1 then hracipole[cerv[1].umx, cerv[1].umy] := obj_empty;
              cerv[1].pozx := cerv[1].umx * 32;
              cerv[1].pozy := cerv[1].umy * 32 + 10;
              if hracipole[cerv[1].umx-1, cerv[1].umy] = obj_flag then
              begin
                sndplaysound('victory.wav', 1);
                dalsil := true;
              end;
              dec(cerv[1].umx);
              cerv[1].sm := 1;
              if hracipole[cerv[1].umx, cerv[1].umy] = obj_meal then
              begin
                zahraj;
                inc(delka);
                {case cerv[delka-1].sm of
                  1: cerv[delka].umx := cerv[delka-1].umx + 1;
                  2: cerv[delka].umx := cerv[delka-1].umx - 1;
                  3: cerv[delka].umy := cerv[delka-1].umy + 1;
                  4: cerv[delka].umy := cerv[delka-1].umy - 1;
                end;
                cerv[delka].pozx := cerv[delka].umx * 32;
                cerv[delka].pozy := cerv[delka].umy * 32 + 10;}
                cerv[delka].pozx := cerv[delka-1].pozx;
                cerv[delka].pozy := cerv[delka-1].pozy;
                cerv[delka].umx := cerv[delka].pozx div 32;
                cerv[delka].umy := (cerv[delka].pozy - 10) div 32;
                cerv[delka].sm := cerv[delka-1].sm;
                hracipole[cerv[delka].umx, cerv[delka].umy] := obj_body;
              end;
              hracipole[cerv[1].umx, cerv[1].umy] := obj_headl;
            end;
         2: begin
              if (hracipole[cerv[1].umx+1, cerv[1].umy] = obj_wall) or
                (hracipole[cerv[1].umx+1, cerv[1].umy] = obj_poison) or
                (hracipole[cerv[1].umx+1, cerv[1].umy] = obj_body) then
              begin
                sndplaysound('poison.wav', 1);
                konhry := true;
              end;
              if delka = 1 then hracipole[cerv[1].umx, cerv[1].umy] := obj_empty;
              cerv[1].pozx := cerv[1].umx * 32;
              cerv[1].pozy := cerv[1].umy * 32 + 10;
              if hracipole[cerv[1].umx+1, cerv[1].umy] = obj_flag then
              begin
                sndplaysound('victory.wav', 1);
                dalsil := true;
              end;
              inc(cerv[1].umx);
              cerv[1].sm := 2;
              if hracipole[cerv[1].umx, cerv[1].umy] = obj_meal then
              begin
                zahraj;
                inc(delka);
                {case cerv[delka-1].sm of
                  1: cerv[delka].umx := cerv[delka-1].umx + 1;
                  2: cerv[delka].umx := cerv[delka-1].umx - 1;
                  3: cerv[delka].umy := cerv[delka-1].umy + 1;
                  4: cerv[delka].umy := cerv[delka-1].umy - 1;
                end;
                cerv[delka].pozx := cerv[delka].umx * 32;
                cerv[delka].pozy := cerv[delka].umy * 32 + 10;}
                cerv[delka].pozx := cerv[delka-1].pozx;
                cerv[delka].pozy := cerv[delka-1].pozy;
                cerv[delka].umx := cerv[delka].pozx div 32;
                cerv[delka].umy := (cerv[delka].pozy - 10) div 32;
                cerv[delka].sm := cerv[delka-1].sm;
                hracipole[cerv[delka].umx, cerv[delka].umy] := obj_body;
              end;
              hracipole[cerv[1].umx, cerv[1].umy] := obj_headr;
            end;
         3: begin
              if (hracipole[cerv[1].umx, cerv[1].umy-1] = obj_wall) or
                (hracipole[cerv[1].umx, cerv[1].umy-1] = obj_poison) or
                (hracipole[cerv[1].umx, cerv[1].umy-1] = obj_body) then
              begin
                sndplaysound('poison.wav', 1);
                konhry := true;
              end;
              if delka = 1 then hracipole[cerv[1].umx, cerv[1].umy] := obj_empty;
              cerv[1].pozx := cerv[1].umx * 32;
              cerv[1].pozy := cerv[1].umy * 32 + 10;
              if hracipole[cerv[1].umx, cerv[1].umy-1] = obj_flag then
              begin
                sndplaysound('victory.wav', 1);
                dalsil := true;
              end;
              dec(cerv[1].umy);
              cerv[1].sm := 3;
              if hracipole[cerv[1].umx, cerv[1].umy] = obj_meal then
              begin
                zahraj;
                inc(delka);
                {case cerv[delka-1].sm of
                  1: cerv[delka].umx := cerv[delka-1].umx + 1;
                  2: cerv[delka].umx := cerv[delka-1].umx - 1;
                  3: cerv[delka].umy := cerv[delka-1].umy + 1;
                  4: cerv[delka].umy := cerv[delka-1].umy - 1;
                end;
                cerv[delka].pozx := cerv[delka].umx * 32;
                cerv[delka].pozy := cerv[delka].umy * 32 + 10;}
                cerv[delka].pozx := cerv[delka-1].pozx;
                cerv[delka].pozy := cerv[delka-1].pozy;
                cerv[delka].umx := cerv[delka].pozx div 32;
                cerv[delka].umy := (cerv[delka].pozy - 10) div 32;
                cerv[delka].sm := cerv[delka-1].sm;
                hracipole[cerv[delka].umx, cerv[delka].umy] := obj_body;
              end;
              hracipole[cerv[1].umx, cerv[1].umy] := obj_headup;
            end;
         4: begin
              if (hracipole[cerv[1].umx, cerv[1].umy+1] = obj_wall) or
                (hracipole[cerv[1].umx, cerv[1].umy+1] = obj_poison) or
                (hracipole[cerv[1].umx, cerv[1].umy+1] = obj_body) then
              begin
                sndplaysound('poison.wav', 1);
                konhry := true;
              end;
              if delka = 1 then hracipole[cerv[1].umx, cerv[1].umy] := obj_empty;
              cerv[1].pozx := cerv[1].umx * 32;
              cerv[1].pozy := cerv[1].umy * 32 + 10;
              if hracipole[cerv[1].umx, cerv[1].umy+1] = obj_flag then
              begin
                sndplaysound('victory.wav', 1);
                dalsil := true;
              end;
              inc(cerv[1].umy);
              cerv[1].sm := 4;
              if hracipole[cerv[1].umx, cerv[1].umy] = obj_meal then
              begin
                zahraj;
                inc(delka);
                {case cerv[delka-1].sm of
                  1: cerv[delka].umx := cerv[delka-1].umx + 1;
                  2: cerv[delka].umx := cerv[delka-1].umx - 1;
                  3: cerv[delka].umy := cerv[delka-1].umy + 1;
                  4: cerv[delka].umy := cerv[delka-1].umy - 1;
                end;
                cerv[delka].pozx := cerv[delka].umx * 32;
                cerv[delka].pozy := cerv[delka].umy * 32 + 10;}
                cerv[delka].pozx := cerv[delka-1].pozx;
                cerv[delka].pozy := cerv[delka-1].pozy;
                cerv[delka].umx := cerv[delka].pozx div 32;
                cerv[delka].umy := (cerv[delka].pozy - 10) div 32;
                cerv[delka].sm := cerv[delka-1].sm;
                hracipole[cerv[delka].umx, cerv[delka].umy] := obj_body;
              end;
              hracipole[cerv[1].umx, cerv[1].umy] := obj_headl;
            end;
       end;
     end
     else
     begin
       if i = delka then hracipole[cerv[i].umx, cerv[i].umy] := obj_empty;
       cerv[i].pozx := cerv[i].umx * 32;
       cerv[i].pozy := cerv[i].umy * 32 + 10;
       cerv[i].umx := cerv[i-1].umx;
       cerv[i].umy := cerv[i-1].umy;
       cerv[i].sm := cerv[i-1].sm;
       hracipole[cerv[i].umx, cerv[i].umy] := obj_body;
     end;
   for j := 1 to 32 do
     for i := delka downto 1 do
     begin
       case cerv[i].sm of
         1: dec(cerv[i].pozx);
         2: inc(cerv[i].pozx);
         3: dec(cerv[i].pozy);
         4: inc(cerv[i].pozy);
       end;
       if i = 1 then
         case cerv[1].sm of
           1: nakresliBMP(0, cerv[1].pozx, cerv[1].pozy, o4);
           2: nakresliBMP(0, cerv[1].pozx, cerv[1].pozy, o6);
           3: nakresliBMP(0, cerv[1].pozx, cerv[1].pozy, o3);
           4: nakresliBMP(0, cerv[1].pozx, cerv[1].pozy, o5);
         end
       else nakresliBMP(0, cerv[i].pozx, cerv[i].pozy, o2);
     end;
 end;
var
  muze: boolean;
begin
  muze := false;
  repeat
    case klav of
      vk_left  : smer := 1;
      vk_right : smer := 2;
      vk_up    : smer := 3;
      vk_down  : smer := 4;
    end;
    if (stav = st_game) and not konhry then posun;
    if konhry then konechry(false);
    muze := true;
  until muze;
end;

procedure tcerwindow.konechry(jaky: boolean);
var
  i, j: byte;
begin
  stav := st_pause;
  if jaky then
    messagebox(hwindow, 'Fajn, vidm, e jsi machr, tak konme!', 'ervk', mb_Ok);
  if score > skore.body then
  begin
    for j := 0 to 14 do
      for i := 0 to 19 do
        nakresliBMP(0, i*32, j*32+10, o1);
    stav := st_enter;
    strcopy(strvstup, '        ');
    citac := 0;
    drawvstup(0);
  end
  else
  begin
    for j := 0 to 14 do
      for i := 0 to 19 do
        nakresliBMP(0, i*32, j*32+10, o1);
    stav := st_intro;
    drawuvod(0);
  end;
end;

procedure tcerwindow.setupwindow;
var
  i, j: byte;
begin
  uvod := loadbitmap(hinstance, 'UVOD');
  o1 := loadbitmap(hinstance, 'O01');
  o2 := loadbitmap(hinstance, 'O02');
  o3 := loadbitmap(hinstance, 'O03');
  o4 := loadbitmap(hinstance, 'O04');
  o5 := loadbitmap(hinstance, 'O05');
  o6 := loadbitmap(hinstance, 'O06');
  o7 := loadbitmap(hinstance, 'O07');
  o8 := loadbitmap(hinstance, 'O08');
  o9 := loadbitmap(hinstance, 'O09');
  o10 := loadbitmap(hinstance, 'O10');
  t1 := loadbitmap(hinstance, 'T01');
  t2 := loadbitmap(hinstance, 'T02');
  t3 := loadbitmap(hinstance, 'T03');
  t4 := loadbitmap(hinstance, 'T04');
  t5 := loadbitmap(hinstance, 'T05');
  pocitadlo := 0;
  oldx := 0;
  oldy := 0;
  newx := 0;
  newy := 0;
  level := 0;
  for j := 0 to 14 do
    for i := 0 to 19 do
      hracipole[i, j] := obj_empty;
  stav := st_intro;
  ltlac := false;
  rtlac := false;
  boolex := false;
  vytvorfont(thefont);
end;

procedure tcerwindow.vytvorfont(var afont: hfont);
begin
  fillchar(cerfont, sizeof(tlogfont), #0);
  with cerfont do
  begin
    lfHeight := 30;
    lfWidth := 0;
    lfEscapement := 0;
    lfOrientation := 0;
    lfWeight := fw_medium;
    lfItalic := 0;
    lfUnderline := 0;
    lfStrikeOut := 0;
    lfCharSet := 1;
    lfOutPrecision := out_stroke_precis;
    lfClipPrecision := clip_stroke_precis;
    lfQuality := default_quality;
    lfPitchAndFamily := variable_pitch;
    strcopy(lfFaceName, 'Comic Sans MS');
  end;
  thefont := createfontindirect(cerfont);
end;

procedure tcerwindow.wmdestroy(var msg: tmessage);
begin
  zapisprofil;
  deleteobject(uvod);
  deleteobject(o1);
  deleteobject(o2);
  deleteobject(o3);
  deleteobject(o4);
  deleteobject(o5);
  deleteobject(o6);
  deleteobject(o7);
  deleteobject(o8);
  deleteobject(o9);
  deleteobject(o10);
  deleteobject(t1);
  deleteobject(t2);
  deleteobject(t3);
  deleteobject(t4);
  deleteobject(t5);
  if thefont <> 0 then deleteobject(thefont);
  killtimer(hwindow, 1);
  twindow.wmdestroy(msg);
end;

procedure tcerwindow.wmlbuttondown(var msg: tmessage);
begin
  if inside(0, 0, attr.w-21, 9, loword(msg.lparam), hiword(msg.lparam)) then
  begin
    oldx := loword(msg.lparam);
    oldy := hiword(msg.lparam);
    ltlac := true;
  end;
  if inside(attr.w-20, 0, attr.w-10, 9, loword(msg.lparam), hiword(msg.lparam)) then
    boolex := true else boolex := false;
end;

procedure tcerwindow.wmlbuttonup(var msg: tmessage);
begin
  if inside(0, 0, attr.w-21, 9, loword(msg.lparam), hiword(msg.lparam)) then ltlac := false;
  if inside(attr.w-21, 0, attr.w-10, 9, loword(msg.lparam), hiword(msg.lparam)) and
    boolex then closewindow else boolex := false;
end;

procedure tcerwindow.wmrbuttondown(var msg: tmessage);
begin
  if inside(0, 0, attr.w-21, 9, loword(msg.lparam), hiword(msg.lparam)) then
  begin
    oldx := loword(msg.lparam);
    oldy := hiword(msg.lparam);
    rtlac := true;
  end;
  if inside(attr.w-20, 0, attr.w-10, 9, loword(msg.lparam), hiword(msg.lparam)) then
    boolex := true else boolex := false;
end;

procedure tcerwindow.wmrbuttonup(var msg: tmessage);
begin
  if inside(0, 0, attr.w-21, 9, loword(msg.lparam), hiword(msg.lparam)) then rtlac := false;
  if inside(attr.w-21, 0, attr.w-10, 9, loword(msg.lparam), hiword(msg.lparam)) and
    boolex then closewindow else boolex := false;
end;

procedure tcerwindow.wmmousemove(var msg: tmessage);
var
  pomx, pomy: integer;
begin
  if inside(0, 0, attr.w-21, 9, loword(msg.lparam), hiword(msg.lparam)) and
    (ltlac or rtlac) then
  begin
    newx := loword(msg.lparam);
    newy := hiword(msg.lparam);
    if (newx <> oldx) or (newy <> oldy) then
    begin
      pomx := newx-oldx;
      pomy := newy-oldy;
      oknox := oknox + pomx;
      oknoy := oknoy + pomy;
      movewindow(hwindow, oknox, oknoy, 640, 490, true);
    end;
  end;
  if inside(attr.w-20, 0, attr.w-10, 9, loword(msg.lparam), hiword(msg.lparam)) then
    drawex(0, true) else drawex(0, false);
end;

procedure tcerwindow.wmkeydown(var msg: tmessage);
begin
  klav := msg.wparam;
end;

procedure tcerwindow.wmkeyup(var msg: tmessage);
var
  i, j: byte;
begin
  klav := msg.wparam;
  if (klav = vk_return) and (stav = st_intro) then
  begin
    level := 0;
    score := 0;
    novahra;
  end;
  if (klav = vk_escape) and ((stav = st_game) or (stav = st_pause)) then
  begin
    stav := st_pause;
    if messagebox(hwindow, 'Opravdu to chcete vzdt?', 'ervk',
      mb_YesNo or mb_IconQuestion) = id_Yes then konechry(false)
    else stav := st_game;
  end;
  if (klav = vk_pause) and ((stav = st_game) or (stav = st_pause)) then
    if stav = st_game then stav := st_pause else stav := st_game;
  if stav = st_enter then
  begin
    case klav of
      65..90, 97..122, 32: if citac <> 8 then
                  begin
                    inc(citac);
                    strvstup[citac-1] := chr(klav);
                    drawvstup(0);
                  end;
      vk_back   : if citac <> 0 then
                  begin
                    strvstup[citac-1] := ' ';
                    dec(citac);
                    drawvstup(0);
                  end;
      vk_return : begin
                    skore.body := score;
                    strcopy(skore.jmeno, strvstup);
                    stav := st_intro;
                    for j := 0 to 14 do
                      for i := 0 to 19 do
                        nakresliBMP(0, i*32, j*32+10, o1);
                    drawuvod(0);
                  end;
    end;
  end;
end;

procedure tcerwindow.wmtimer(var msg: tmessage);
begin
  inc(pocitadlo);
  case stav of
    st_intro: begin
                if pocitadlo > 10 then
                begin
                  pocitadlo := 0;
                end;
              end;
    st_game : begin
                case level of
                  1..2    : if pocitadlo > 10 then begin pocitadlo := 0; hra; end;
                  3..6    : if pocitadlo > 9 then begin pocitadlo := 0; hra; end;
                  7..14   : if pocitadlo > 8 then begin pocitadlo := 0; hra; end;
                  15..30  : if pocitadlo > 7 then begin pocitadlo := 0; hra; end;
                  31..62  : if pocitadlo > 6 then begin pocitadlo := 0; hra; end;
                  63..126 : if pocitadlo > 5 then begin pocitadlo := 0; hra; end;
                  127..255: if pocitadlo > 4 then begin pocitadlo := 0; hra; end;
                end;
                if dalsil then
                begin
                  klav := 0;
                  novahra;
                end;
              end;
    st_pause: begin
                if pocitadlo > 10 then
                begin
                  pocitadlo := 0;
                  hra;
                end;
              end;
    st_enter: begin
                if pocitadlo > 10 then
                begin
                  pocitadlo := 0;
                end;
              end;
  end;
end;

procedure tcerwindow.wmsize(var msg: tmessage);
begin
  if isiconic(hwindow) then killtimer(hwindow, 1)
  else
    if settimer(hwindow, 1, 10, nil) = 0 then {10 - 0,1 sec, ne 0,01 sec}
    begin
      messagebox(hwindow, 'Neb as.', 'Chyba', mb_Ok or mb_IconStop);
      halt;
    end;
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(pcerwindow, init(nil, 'ervk'));
end;

procedure nactiprofil;
begin
  getprivateprofilestring('Cervik', 'Name', 'ham SOFT', skore.jmeno, sizeof(skore.jmeno), inifile);
  skore.body := getprivateprofileint('Cervik', 'Score', 0, inifile);
  zvuky := getprivateprofileint('Cervik', 'Sound', 1, inifile);
  oknox := getprivateprofileint('Cervik', 'PosX', 0, inifile);
  oknoy := getprivateprofileint('Cervik', 'PosY', 0, inifile);
end;

procedure zapisprofil;
var
  s: array[0..5] of char;
begin
  writeprivateprofilestring('Cervik', 'Name', skore.jmeno, inifile);
  str(integer(skore.body), s);
  writeprivateprofilestring('Cervik', 'Score', s, inifile);
  str(integer(zvuky), s);
  writeprivateprofilestring('Cervik', 'Sound', s, inifile);
  str(integer(oknox), s);
  writeprivateprofilestring('Cervik', 'PosX', s, inifile);
  str(integer(oknoy), s);
  writeprivateprofilestring('Cervik', 'PosY', s, inifile);
end;

var
  app: tapp;
begin
  nactiprofil;
  if zvuky <> 0 then sndplaysound('victory.wav', 1);
  app.init('ervk');
  app.run;
  app.done;
end.