program Letadlo;
{$r letadlo}
uses
  wintypes, winprocs, owindows, odialogs, strings;

const
  inifile = 'LETADLO.INI';

type
  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

  bod = record
          x, y: integer;
        end;
  prekazka = record
               x, y: integer;
             end;

  pletwindow = ^tletwindow;
  tletwindow = object(twindow)
    skore, tlac, ero, vybuch, bodik, prekaz, otaz,
    pauz, pokr, zivo                             : hbitmap;
    hra, pauza, stisk                            : boolean;
    pocitadlo, body, zivoty, bestsc, cx, cy      : integer;
    bodiky                                       : array[1..16] of bod;
    prekazky                                     : array[1..6] of prekazka;
    constructor init(aparent: pwindowsobject; title: pchar);
    function canclose: boolean; virtual;
    function inside(x1, y1, x2, y2, x, y: integer): boolean;
    procedure nakresliBMP(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(paintdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure setupwindow; virtual;
    procedure nakresliokraje(dc: hdc);
    procedure nakreslimenu(dc: hdc);
    procedure nakresliletadlo(dc: hdc);
    procedure nakreslivybuch(x, y: integer; dc: hdc);
    procedure game;
    procedure nactiprofil;
    procedure zapisprofil;
    procedure wmdestroy(var msg: tmessage); virtual wm_destroy;
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown + wm_first;
    procedure wmlbuttonup(var msg: tmessage); virtual wm_lbuttonup + wm_first;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown + wm_first;
    procedure wmrbuttonup(var msg: tmessage); virtual wm_rbuttonup + wm_first;
    procedure wmtimer(var msg: tmessage); virtual wm_timer + wm_first;
    procedure wmsize(var msg: tmessage); virtual wm_size + wm_first;
  end;

constructor tletwindow.init(aparent: pwindowsobject; title: pchar);
begin
  twindow.init(aparent, title);
  attr.w := 200;
  attr.h := 150;
  attr.style := ws_caption or ws_sysmenu or ws_minimizebox;
  randomize;
end;

function tletwindow.canclose: boolean;
begin
  messagebox(hwindow, 'Zdrav Vs HAM Software!', 'Letadlo', mb_Ok or mb_IconInformation);
end;

function tletwindow.inside(x1, y1, x2, y2, x, y: integer): boolean;
begin
  inside := (x1 <= x) and (y1 <= y) and (x2 >= x) and (y2 >= y);
end;

procedure tletwindow.nakresliBMP(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(otaz, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tletwindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  wndclass.style := 0;
  wndclass.hbrbackground := getstockobject(white_brush);
  wndclass.hicon := loadicon(hinstance, 'IKONA');
end;

procedure tletwindow.paint(paintdc: hdc; var paintinfo: tpaintstruct);
begin
  if not hra then nakreslimenu(paintdc)
  else
  begin
    nakresliokraje(paintdc);
    nakresliletadlo(paintdc);
  end;
end;

procedure tletwindow.setupwindow;
begin
  skore := loadbitmap(hinstance, 'SKORE');
  bodik := loadbitmap(hinstance, 'BODIK');
  ero := loadbitmap(hinstance, 'LETADLO');
  tlac := loadbitmap(hinstance, 'TLAC');
  vybuch := loadbitmap(hinstance, 'VYBUCH');
  prekaz := loadbitmap(hinstance, 'PREKAZKA');
  otaz := loadbitmap(hinstance, 'OTAZ');
  pauz := loadbitmap(hinstance, 'PAUZ');
  pokr := loadbitmap(hinstance, 'POKR');
  zivo := loadbitmap(hinstance, 'ZIVO');
  cx := 50;
  cy := 60;
  zivoty := 3;
  body := 0;
  bestsc := 0;
  pocitadlo := 0;
  hra := false;
  pauza := false;
  stisk := false;
  nactiprofil;
end;

procedure tletwindow.nakresliokraje(dc: hdc);
var
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  selectobject(dc, createsolidbrush($0000));
  selectobject(dc, getstockobject(null_pen));
  setbkmode(dc, transparent);
  rectangle(dc, 0, 0, 200, 33);
  rectangle(dc, 0, 87, 200, 150);
  deleteobject(selectobject(dc, getstockobject(white_brush)));
  selectobject(dc, getstockobject(null_pen));
  if madedc then releasedc(hwindow, dc);
end;

procedure tletwindow.nakreslimenu(dc: hdc);
var
  madedc: boolean;
  s     : array[0..20] of char;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  selectobject(dc, createsolidbrush($0000));
  selectobject(dc, getstockobject(null_pen));
  setbkmode(dc, transparent);
  nakresliBMP(dc, 0, 0, skore);
  str(bestsc:5, s);
  textout(dc, 5, 35, s, strlen(s));
  nakresliBMP(dc, 136, 0, tlac);
  nakresliBMP(dc, 68, 60, otaz);
  deleteobject(selectobject(dc, getstockobject(white_brush)));
  selectobject(dc, getstockobject(null_pen));
  if madedc then releasedc(hwindow, dc);
end;

procedure tletwindow.nakresliletadlo(dc: hdc);
var
  i     : byte;
  madedc: boolean;
begin
  nakresliBMP(dc, cx, cy, ero);
  for i := 1 to 16 do nakresliBMP(dc, bodiky[i].x, bodiky[i].y, bodik);
  if pauza then nakresliBMP(dc, 136, 87, pokr)
  else nakresliBMP(dc, 136, 87, pauz);
  if zivoty >= 1 then
    for i := 1 to zivoty do nakresliBMP(dc, 20*i+2, 0, zivo);
  for i := 1 to 6 do nakresliBMP(dc, prekazky[i].x, prekazky[i].y, prekaz);
end;

procedure tletwindow.nakreslivybuch(x, y: integer; dc: hdc);
var
  madedc: boolean;
begin
  nakresliBMP(dc, x, y, vybuch);
end;

procedure tletwindow.game;
var
  i: byte;
begin
  if not hra then
  begin
    hra := true;
    pauza := false;
    body := 0;
    pocitadlo := 0;
    zivoty := 3;
    for i := 16 downto 1 do
    begin
      bodiky[i].y := cy + 8;
      bodiky[i].x := 50 - 3 * i;
    end;
    for i := 1 to 6 do
    begin
      prekazky[i].x := 150+100*i;
      prekazky[i].y := random(23)+33;
    end;
    invalidaterect(hwindow, nil, true);
  end;
  if zivoty < 0 then
  begin
    if body > bestsc then
    begin
      bestsc := body;
      messagebox(hwindow, 'Gratuluji! M nejlep skre!', 'Letadlo', mb_Ok);
    end;
    hra := false;
    pauza := false;
  end;
  for i := 16 downto 1 do
  begin
    bodiky[i].y := cy + 8;
    bodiky[i].x := 50 - 3 * i;
  end;
  for i := 1 to 6 do
  begin
    prekazky[i].x := 150+100*i;
    prekazky[i].y := random(23)+33;
  end;
  invalidaterect(hwindow, nil, true);
end;

procedure tletwindow.nactiprofil;
begin
  bestsc := getprivateprofileint('Letadlo', 'BestScore', 0, inifile);
end;

procedure tletwindow.zapisprofil;
var
  s: array[0..5] of char;
begin
  str(integer(bestsc), s);
  writeprivateprofilestring('Letadlo', 'BestScore', s, inifile);
end;

procedure tletwindow.wmdestroy(var msg: tmessage);
begin
  zapisprofil;
  deleteobject(skore);
  deleteobject(ero);
  deleteobject(tlac);
  deleteobject(vybuch);
  deleteobject(bodik);
  deleteobject(prekaz);
  deleteobject(otaz);
  deleteobject(pauz);
  deleteobject(pokr);
  deleteobject(zivo);
  killtimer(hwindow, 1);
  twindow.wmdestroy(msg);
end;

procedure tletwindow.wmlbuttondown(var msg: tmessage);
begin
  if not hra then
  begin
    if inside(136, 0, 200, 32, msg.lparamlo, msg.lparamhi) then game;
    if inside(68, 60, 132, 124, msg.lparamlo, msg.lparamhi) then
    begin
      messagebeep(mb_IconQuestion);
      application^.execdialog(new(pdialog, init(@self, 'OPROG')));
    end;
  end;
  if hra and not pauza then stisk := true;
  if inside(136, 87, 200, 119, msg.lparamlo, msg.lparamhi) and hra then
  begin
    if pauza then pauza := false
    else pauza := true;
    nakresliletadlo(0);
  end;
end;

procedure tletwindow.wmlbuttonup(var msg: tmessage);
begin
  if hra and not pauza then stisk := false;
end;

procedure tletwindow.wmrbuttondown(var msg: tmessage);
begin
  if not hra then
  begin
    if inside(136, 0, 200, 32, msg.lparamlo, msg.lparamhi) then game;
    if inside(68, 60, 132, 124, msg.lparamlo, msg.lparamhi) then
    begin
      messagebeep(mb_IconQuestion);
      application^.execdialog(new(pdialog, init(@self, 'OPROG')));
    end;
  end;
  if hra and not pauza then stisk := true;
  if inside(136, 87, 200, 119, msg.lparamlo, msg.lparamhi) and hra then
  begin
    if pauza then pauza := false
    else pauza := true;
    nakresliletadlo(0);
  end;
end;

procedure tletwindow.wmrbuttonup(var msg: tmessage);
begin
  if hra and not pauza then stisk := false;
end;

procedure tletwindow.wmtimer(var msg: tmessage);
var
  i, j: byte;
  nej : integer;
begin
  inc(pocitadlo);
  if pocitadlo = 1 then
  begin
    pocitadlo := 0;
    if hra and not pauza then
    begin
      if not stisk then cy := cy + 1
      else cy := cy - 1;
      if cy > 87-14 then
      begin
        nakreslivybuch(cx, cy, 0);
        zivoty := zivoty - 1;
        cy := 60;
        game;
      end;
      if cy < 33 then
      begin
        nakreslivybuch(cx, cy, 0);
        zivoty := zivoty - 1;
        cy := 60;
        game;
      end;
      for i := 16 downto 1 do
      begin
        bodiky[i].x := bodiky[i].x - 2;
        if bodiky[i].x < -1 then
        begin
          bodiky[i].x := cx - 3;
          bodiky[i].y := cy + 8;
        end;
      end;
      for i := 1 to 6 do
      begin
        prekazky[i].x := prekazky[i].x - 2;
        if prekazky[i].x < -15 then
        begin
          body := body + 2;
          nej := 0;
          for j := 1 to 6 do
            if prekazky[j].x > nej then nej := prekazky[j].x;
          prekazky[i].x := nej + 100;
          prekazky[i].y := random(23)+33;
        end;
        if inside(prekazky[i].x, prekazky[i].y, prekazky[i].x+15,
            prekazky[i].y+15, cx, cy) or
          inside(prekazky[i].x, prekazky[i].y, prekazky[i].x+15,
            prekazky[i].y+15, cx+16, cy) or
          inside(prekazky[i].x, prekazky[i].y, prekazky[i].x+15,
            prekazky[i].y+15, cx+16, cy+14) or
          inside(prekazky[i].x, prekazky[i].y, prekazky[i].x+15,
            prekazky[i].y+15, cx, cy+14) then
        begin
          nakreslivybuch(cx, cy, 0);
          zivoty := zivoty - 1;
          cy := 60;
          game;
        end;
      end;
      nakresliletadlo(0);
    end;
  end;
end;

procedure tletwindow.wmsize(var msg: tmessage);
begin
  if isiconic(hwindow) then killtimer(hwindow, 1)
  else
    if settimer(hwindow, 1, 100, nil) = 0 then
    begin
      messagebox(hwindow, 'Neb as.', 'Chyba', mb_Ok or mb_IconStop);
      halt;
    end;
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(pletwindow, init(nil, 'Letadlo'));
end;

var
  app: tapp;
begin
  app.init('Letadlo');
  app.run;
  app.done;
end.