program _Miny_;
{$r miny}
uses
  winprocs, owindows, wintypes, strings;

const
  sirka = 19;
  vyska = 19;

type
  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

  pminywindow = ^tminywindow;
  tminywindow = object(twindow)
    ctver1, ctver2, ctver3, ctver4, ctver5, ctver6, ctver7, c1, c2, c3, c4,
    c5, c6, c7, c8, but1, but2, but3, but4, but5, obr1, obr2, bmpokno, zav1,
    zav2, labobr                                 : hbitmap;
    pocitadlo, pocetmin, zbmin, konec            : byte;
    cas, oldx, oldy, newx, newy, oknox, oknoy    : integer;
    boolex, hra, ltlac, mycheck                  : boolean;
    pole, polm                                   : array[0..19, 0..19] of byte;
    maska                                        : array[0..19, 0..19] of boolean;
    pomx, pomy                                   : array[0..400] of integer;
    pomindex                                     : array[0..19, 0..19] of integer;
    minyfont                                     : tlogfont;
    thefont                                      : hfont;
    constructor init(aparent: pwindowsobject; title: pchar);
    function inside(x1, y1, x2, y2, x, y: integer): boolean;
    procedure nakresliBMP(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(paintdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure setupwindow; virtual;
    procedure vytvorfont(var afont: hfont);
    procedure drawzav(dc: hdc; jake: byte);
    procedure drawtlac(dc: hdc; jake: byte);
    procedure drawskrt(dc: hdc; jake: byte);
    procedure drawlab(dc: hdc);
    procedure drawminy(dc: hdc; jake: byte);
    procedure novahra;
    procedure overvitez;
    procedure odkryj(cx, cy: byte);
    procedure odklikej(pmx, pmy: byte);
    procedure klik(kx, ky: byte);
    procedure wmdestroy(var msg: tmessage); virtual wm_destroy;
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown + wm_first;
    procedure wmlbuttonup(var msg: tmessage); virtual wm_lbuttonup + wm_first;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown + wm_first;
    procedure wmrbuttonup(var msg: tmessage); virtual wm_rbuttonup + wm_first;
    procedure wmmousemove(var msg: tmessage); virtual wm_mousemove + wm_first;
    procedure wmtimer(var msg: tmessage); virtual wm_timer + wm_first;
    procedure wmsize(var msg: tmessage); virtual wm_size + wm_first;
  end;

constructor tminywindow.init(aparent: pwindowsobject; title: pchar);
begin
  twindow.init(aparent, title);
  randomize;
  oknox := random(100);
  oknoy := random(100);
  attr.x := oknox;
  attr.y := oknoy;
  attr.w := 306;
  attr.h := 357;
  attr.style := ws_popup;
  thefont := 0;
end;

function tminywindow.inside(x1, y1, x2, y2, x, y: integer): boolean;
begin
  inside := (x1 <= x) and (y1 <= y) and (x2 >= x) and (y2 >= y);
end;

procedure tminywindow.nakresliBMP(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(bmpokno, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tminywindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  wndclass.style := 0;
  wndclass.hbrbackground := getstockobject(white_brush);
  wndclass.hicon := loadicon(hinstance, 'IKONA');
end;

procedure tminywindow.paint(paintdc: hdc; var paintinfo: tpaintstruct);
begin
  nakresliBMP(paintdc, 0, 0, bmpokno);
  drawzav(paintdc, 0);
  if konec = 0 then drawtlac(paintdc, 0);
  if konec = 1 then drawtlac(paintdc, 2);
  if konec = 2 then drawtlac(paintdc, 3);
  if mycheck then drawskrt(paintdc, 0)
  else drawskrt(paintdc, 1);
  drawlab(paintdc);
  if konec <> 0 then drawminy(paintdc, 1)
  else drawminy(paintdc, 0);
end;

procedure tminywindow.setupwindow;
var
  i, j: byte;
  k   : integer;
begin
  bmpokno := loadbitmap(hinstance, 'OKNO');
  zav1 := loadbitmap(hinstance, 'ZAV1');
  zav2 := loadbitmap(hinstance, 'ZAV2');
  obr1 := loadbitmap(hinstance, 'OBR1');
  obr2 := loadbitmap(hinstance, 'OBR2');
  c1 := loadbitmap(hinstance, 'C1');
  c2 := loadbitmap(hinstance, 'C2');
  c3 := loadbitmap(hinstance, 'C3');
  c4 := loadbitmap(hinstance, 'C4');
  c5 := loadbitmap(hinstance, 'C5');
  c6 := loadbitmap(hinstance, 'C6');
  c7 := loadbitmap(hinstance, 'C7');
  c8 := loadbitmap(hinstance, 'C8');
  ctver1 := loadbitmap(hinstance, 'CTVER1');
  ctver2 := loadbitmap(hinstance, 'CTVER2');
  ctver3 := loadbitmap(hinstance, 'CTVER3');
  ctver4 := loadbitmap(hinstance, 'CTVER4');
  ctver5 := loadbitmap(hinstance, 'CTVER5');
  ctver6 := loadbitmap(hinstance, 'CTVER6');
  ctver7 := loadbitmap(hinstance, 'CTVER7');
  but1 := loadbitmap(hinstance, 'BUT1');
  but2 := loadbitmap(hinstance, 'BUT2');
  but3 := loadbitmap(hinstance, 'BUT3');
  but4 := loadbitmap(hinstance, 'BUT4');
  but5 := loadbitmap(hinstance, 'BUT5');
  labobr := loadbitmap(hinstance, 'LABOBR');
  mycheck := true;
  boolex := false;
  ltlac := false;
  k := 0;
  for j := 0 to vyska do
    for i := 0 to sirka do
    begin
      inc(k);
      pomindex[i, j] := k;
      pomx[k] := i;
      pomy[k] := j;
    end;
  vytvorfont(thefont);
  novahra;
end;

procedure tminywindow.vytvorfont(var afont: hfont);
begin
  fillchar(minyfont, sizeof(tlogfont), #0);
  with minyfont do
  begin
    lfHeight := 8;
    lfWidth := 0;
    lfEscapement := 0;
    lfOrientation := 0;
    lfWeight := fw_medium;
    lfItalic := 0;
    lfUnderline := 0;
    lfStrikeOut := 0;
    lfCharSet := 1;
    lfOutPrecision := out_stroke_precis;
    lfClipPrecision := clip_stroke_precis;
    lfQuality := default_quality;
    lfPitchAndFamily := variable_pitch;
    strcopy(lfFaceName, 'MS Sans Serif');
  end;
  thefont := createfontindirect(minyfont);
end;

procedure tminywindow.drawzav(dc: hdc; jake: byte);
begin
 case jake of
  0: nakresliBMP(dc, 281, 6, zav2);
  1: nakresliBMP(dc, 281, 6, zav1);
 end;
end;

procedure tminywindow.drawtlac(dc: hdc; jake: byte);
begin
  case jake of
   0: nakresliBMP(dc, 141, 29, but1);
   1: nakresliBMP(dc, 141, 29, but2);
   2: nakresliBMP(dc, 141, 29, but3);
   3: nakresliBMP(dc, 141, 29, but4);
   4: nakresliBMP(dc, 141, 29, but5);
  end;
end;

procedure tminywindow.drawskrt(dc: hdc; jake: byte);
begin
 case jake of
  0: nakresliBMP(dc, 66, 34, obr1);
  1: nakresliBMP(dc, 66, 34, obr2);
 end;
end;

procedure tminywindow.drawlab(dc: hdc);
var
  madedc: boolean;
  pomstr: array[0..10] of char;
  celek : array[0..20] of char;
  pomoc : byte;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  nakresliBMP(dc, 5, 31, labobr);
  nakresliBMP(dc, 251, 31, labobr);
  selectobject(dc, thefont);
  settextcolor(dc, rgb(240, 240, 0));
  setbkmode(dc, transparent);
  settextalign(dc, ta_left);
  str(zbmin, pomstr);
  pomoc := zbmin;
  if (zbmin > 20) and (zbmin < 30) then pomoc := zbmin - 20;
  if (zbmin > 30) and (zbmin < 40) then pomoc := zbmin - 30;
  if (zbmin > 40) and (zbmin < 50) then pomoc := zbmin - 40;
  if (zbmin > 50) and (zbmin < 60) then pomoc := zbmin - 50;
  strecopy(strecopy(celek, pomstr), ' min');
  if pomoc = 1 then
    strecopy(strecopy(celek, pomstr), ' mina');
  if (pomoc > 1) and (pomoc < 5) then
    strecopy(strecopy(celek, pomstr), ' miny');
  textout(dc, 5, 31, celek, strlen(celek));
  str(cas, pomstr);
  strecopy(strecopy(celek, pomstr), 's');
  textout(dc, 251, 31, celek, strlen(celek));
  if madedc then releasedc(hwindow, dc);
end;

procedure tminywindow.drawminy(dc: hdc; jake: byte);
var
  i, j  : byte;
  nemuze: boolean;
begin
  for j := 0 to vyska do
    for i := 0 to sirka do
    begin
      nemuze := false;
      if maska[i, j] then
        case polm[i, j] of
         0: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver1);
         1: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver3);
         2: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver4);
        end
      else
        case pole[i, j] of
         0: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver2);
         1: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c1);
         2: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c2);
         3: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c3);
         4: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c4);
         5: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c5);
         6: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c6);
         7: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c7);
         8: nakresliBMP(dc, i * 15 + 3, j * 15 + 54, c8);
         10: begin
               nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver6);
               nemuze := true;
             end;
        end;
      if jake = 1 then
      begin
        if (pole[i, j] = 10) and not nemuze and (polm[i, j] <> 1) then
          nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver5);
        if (polm[i, j] = 1) and (pole[i, j] <> 10) then
          nakresliBMP(dc, i * 15 + 3, j * 15 + 54, ctver7);
      end;
    end;
end;

procedure tminywindow.novahra;
var
  i, j: byte;
  k   : integer;
begin
  pocitadlo := 0;
  if mycheck then pocetmin := 54
  else pocetmin := 27;
  zbmin := pocetmin;
  cas := 0;
  konec := 0;
  hra := false;
  k := 0;
  for j := 0 to vyska do
    for i := 0 to sirka do
    begin
      pole[i, j] := 0;
      polm[i, j] := 0;
      maska[i, j] := true;
    end;
  k := pocetmin;
  repeat
    i := random(sirka + 1);
    j := random(vyska + 1);
    if pole[i, j] = 0 then
    begin
      pole[i, j] := 10;
      dec(k);
    end;
  until (k = 0);
  drawlab(0);
  drawminy(0, 0);
  drawtlac(0, 0);
end;

procedure tminywindow.overvitez;
var
  i, j: byte;
  k   : integer;
begin
  if not hra then exit;
  k := 0;
  for j := 0 to vyska do
    for i := 0 to sirka do
      if not maska[i, j] then inc(k);
  if (k + pocetmin) = ((sirka + 1) * (vyska + 1)) then
  begin
    hra := false;
    konec := 2;
    drawtlac(0, 3);
    drawminy(0, 1);
  end;
end;

procedure tminywindow.odkryj(cx, cy: byte);
var
  k: byte;
begin
  if not maska[cx, cy] then exit;
  maska[cx, cy] := false;
  k := 0;
  if (cy > 0) then
  begin
    if (cx > 0) then
      if pole[cx - 1, cy - 1] = 10 then inc(k);
    if pole[cx, cy - 1] = 10 then inc(k);
    if (cx < sirka) then
      if pole[cx + 1, cy - 1] = 10 then inc(k);
  end;
  if (cx > 0) then
    if pole[cx - 1, cy] = 10 then inc(k);
  if (cx < sirka) then
    if pole[cx + 1, cy] = 10 then inc(k);
  if (cy < vyska) then
  begin
    if (cx > 0) then
      if pole[cx - 1, cy + 1] = 10 then inc(k);
    if pole[cx, cy + 1] = 10 then inc(k);
    if (cx < sirka) then
      if pole[cx + 1, cy + 1] = 10 then inc(k);
  end;
  if (k = 0) then
  begin
    pole[cx, cy] := 0;
    nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, ctver2);
  end
  else
  begin
    pole[cx, cy] := k;
    case k of
      1: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c1);
      2: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c2);
      3: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c3);
      4: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c4);
      5: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c5);
      6: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c6);
      7: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c7);
      8: nakresliBMP(0, cx * 15 + 3, cy * 15 + 54, c8);
    end;
  end;
  overvitez;
end;

procedure tminywindow.odklikej(pmx, pmy: byte);
begin
  overvitez;
  if (pmy > 0) then
  begin
    if (pmx > 0) then klik(pmx - 1, pmy - 1);
    klik(pmx, pmy - 1);
    if (pmx < sirka) then klik(pmx + 1, pmy - 1);
  end;
  if (pmx > 0) then klik(pmx - 1, pmy);
  if (pmx < sirka) then klik(pmx + 1, pmy);
  if (pmy < vyska) then
  begin
    if (pmx > 0) then klik(pmx - 1, pmy + 1);
    klik(pmx, pmy + 1);
    if (pmx < sirka) then klik(pmx + 1, pmy + 1);
  end;
end;

procedure tminywindow.klik(kx, ky: byte);
begin
  if konec = 0 then hra := true;
  if not hra then exit;
  if not maska[kx, ky] then exit;
  if polm[kx, ky] <> 1 then
  begin
    if pole[kx, ky] = 10 then
    begin
      konec := 1;
      hra := false;
      maska[kx, ky] := false;
      nakresliBMP(0, kx * 15 + 3, ky * 15 + 54, ctver6);
      drawtlac(0, 2);
      drawminy(0, 1);
      exit;
    end;
    odkryj(kx, ky);
    if pole[kx, ky] = 0 then
    begin
      overvitez;
      odklikej(kx, ky);
    end;
  end;
end;

procedure tminywindow.wmdestroy(var msg: tmessage);
begin
  deleteobject(bmpokno);
  deleteobject(zav1);
  deleteobject(zav2);
  deleteobject(obr1);
  deleteobject(obr2);
  deleteobject(c1);
  deleteobject(c2);
  deleteobject(c3);
  deleteobject(c4);
  deleteobject(c5);
  deleteobject(c6);
  deleteobject(c7);
  deleteobject(c8);
  deleteobject(ctver1);
  deleteobject(ctver2);
  deleteobject(ctver3);
  deleteobject(ctver4);
  deleteobject(ctver5);
  deleteobject(ctver6);
  deleteobject(ctver7);
  deleteobject(but1);
  deleteobject(but2);
  deleteobject(but3);
  deleteobject(but4);
  deleteobject(but5);
  deleteobject(labobr);
  if thefont <> 0 then deleteobject(thefont);
  killtimer(hwindow, 1);
  twindow.wmdestroy(msg);
end;

procedure tminywindow.wmlbuttondown(var msg: tmessage);
begin
  if inside(281, 6, 300, 25, loword(msg.lparam), hiword(msg.lparam)) then
    boolex := true;
  if inside(0, 0, 306, 29, loword(msg.lparam), hiword(msg.lparam)) and
    not inside(281, 6, 300, 25, loword(msg.lparam), hiword(msg.lparam)) then
  begin
    ltlac := true;
    oldx := loword(msg.lparam);
    oldy := hiword(msg.lparam);
  end;
  if inside(3, 54, 302, 353, loword(msg.lparam), hiword(msg.lparam)) then
  begin
    if hra then drawtlac(0, 1);
    klik((loword(msg.lparam) - 3) div 15, (hiword(msg.lparam) - 54) div 15);
  end;
  if inside(141, 29, 166, 54, loword(msg.lparam), hiword(msg.lparam)) then
    drawtlac(0, 4);
end;

procedure tminywindow.wmlbuttonup(var msg: tmessage);
begin
  if inside(0, 0, 306, 29, loword(msg.lparam), hiword(msg.lparam)) and
    not inside(281, 6, 300, 25, loword(msg.lparam), hiword(msg.lparam)) then
    ltlac := false;
  if hra then drawtlac(0, 0);
  if inside(141, 29, 166, 54, loword(msg.lparam), hiword(msg.lparam)) then
    novahra;
  if konec = 1 then drawtlac(0, 2);
  if inside(64, 30, 118, 45, loword(msg.lparam), hiword(msg.lparam)) then
  begin
    if mycheck then
    begin
      mycheck := false;
      drawskrt(0, 1);
    end
    else
    begin
      mycheck := true;
      drawskrt(0, 0);
    end;
    novahra;
  end;
  if inside(281, 6, 300, 25, loword(msg.lparam), hiword(msg.lparam)) and boolex
  then closewindow
  else boolex := false;
end;

procedure tminywindow.wmrbuttondown(var msg: tmessage);
var
  zmena : boolean;
  kx, ky: byte;
begin
  if inside(3, 54, 302, 353, loword(msg.lparam), hiword(msg.lparam)) then
  begin
    if hra then drawtlac(0, 1);
    if konec = 0 then hra := true;
    if not hra then exit;
    zmena := false;
    kx := (loword(msg.lparam) - 3) div 15;
    ky := (hiword(msg.lparam) - 54) div 15;
    if not maska[kx, ky] then exit;
    if (polm[kx, ky] = 1) and not zmena then
    begin
      inc(zbmin);
      zmena := true;
      nakresliBMP(0, kx * 15 + 3, ky * 15 + 54, ctver4);
      polm[kx, ky] := 2;
    end;
    if (polm[kx, ky] = 0) and not zmena and (zbmin > 0) then
    begin
      dec(zbmin);
      zmena := true;
      nakresliBMP(0, kx * 15 + 3, ky * 15 + 54, ctver3);
      polm[kx, ky] := 1;
    end;
    if (polm[kx, ky] = 2) and not zmena then
    begin
      zmena := true;
      nakresliBMP(0, kx * 15 + 3, ky * 15 + 54, ctver1);
      polm[kx, ky] := 0;
    end;
    drawlab(0);
  end;
end;

procedure tminywindow.wmrbuttonup(var msg: tmessage);
begin
  if hra then drawtlac(0, 0);
end;

procedure tminywindow.wmmousemove(var msg: tmessage);
var
  pmx, pmy: integer;
begin
  if inside(281, 6, 300, 25, loword(msg.lparam), hiword(msg.lparam)) then
    drawzav(0, 1)
  else
    drawzav(0, 0);
  if inside(0, 0, 306, 29, loword(msg.lparam), hiword(msg.lparam)) and ltlac
  then
  begin
    newx := loword(msg.lparam);
    newy := hiword(msg.lparam);
    if (newx <> oldx) or (newy <> oldy) then
    begin
      pmx := newx - oldx;
      pmy := newy - oldy;
      oknox := oknox + pmx;
      oknoy := oknoy + pmy;
      movewindow(hwindow, oknox, oknoy, 306, 357, true);
    end;
  end;
end;

procedure tminywindow.wmtimer(var msg: tmessage);
begin
  inc(pocitadlo);
  if pocitadlo = 10 then
  begin
    pocitadlo := 0;
    if hra then
    begin
      inc(cas);
      drawlab(0);
      if cas > 999 then
      begin
        hra := false;
        konec := 1;
        drawminy(0, 1);
        messagebox(hwindow, 'Prohrl jsi, vyprel ti as!', 'Miny', mb_Ok or mb_IconInformation);
      end;
    end;
  end;
end;

procedure tminywindow.wmsize(var msg: tmessage);
begin
  if isiconic(hwindow) then killtimer(hwindow, 1)
  else
    if settimer(hwindow, 1, 100, nil) = 0 then
    begin
      messagebox(hwindow, 'Neb as.', 'Chyba', mb_Ok or mb_IconStop);
      halt;
    end;
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(pminywindow, init(nil, 'Miny'));
end;

var
  app: tapp;
begin
  app.init('Miny');
  app.run;
  app.done;
end.