program piskvorky;
{$r pikvork.res}
uses
  wintypes, winprocs, owindows, odialogs, strings;
type
  ppiswindow = ^tpiswindow;
  tpiswindow = object(twindow)
    pole, krizek, krizeks, kolecko, koleckos: hbitmap;
    hra, dabl, zahral: boolean;
    mx, my, pocitadlo: integer;
    hracipole: array[1..16, 1..16] of integer;
    constructor init(aparent: pwindowsobject; atitle: pchar);
    procedure obraz(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(obrdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure setupwindow; virtual;
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown;
    procedure plocha(dc: hdc);
    procedure zjisti(hrac: integer);
    procedure vyber;
    procedure odpovez;
    procedure premyslej(jak: boolean);
  end;
  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

constructor tpiswindow.init(aparent: pwindowsobject; atitle: pchar);
begin
  twindow.init(aparent, atitle);
  attr.w := 386;
  attr.h := 405;
  attr.style := ws_caption or ws_sysmenu or ws_minimizebox;
end;

procedure tpiswindow.obraz(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(pole, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tpiswindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  wndclass.style := 0;
  wndclass.hicon := loadicon(hinstance, 'IKONA');
end;

procedure tpiswindow.paint(obrdc: hdc; var paintinfo: tpaintstruct);
begin
  plocha(obrdc);
end;

procedure tpiswindow.setupwindow;
var
  i, j: integer;
begin
  pole := loadbitmap(hinstance, 'POLE');
  krizek := loadbitmap(hinstance, 'KRIZEK');
  kolecko := loadbitmap(hinstance, 'KOLECKO');
  krizeks := loadbitmap(hinstance, 'KRIZEKS');
  koleckos := loadbitmap(hinstance, 'KOLECKOS');
  pocitadlo := 1;
  dabl := true;
  for i := 1 to 16 do for j := 1 to 16 do hracipole[i, j] := 0;
  hra := true;
end;

procedure tpiswindow.wmlbuttondown(var msg: tmessage);
begin
  mx := msg.lparamlo;
  my := msg.lparamhi;
  vyber;
end;

procedure tpiswindow.wmrbuttondown(var msg: tmessage);
begin
  mx := msg.lparamlo;
  my := msg.lparamhi;
  vyber;
end;

procedure tpiswindow.plocha(dc: hdc);
var
  i, j, px, py: integer;
begin
  py := 0;
  for i := 1 to 16 do
  begin
    px := 0;
    for j := 1 to 16 do
    begin
      case hracipole[j, i] of
        0: obraz(dc, px, py, pole);
        1: obraz(dc, px, py, krizek);
        2: obraz(dc, px, py, kolecko);
        3: obraz(dc, px, py, krizeks);
        4: obraz(dc, px, py, koleckos);
      end;
      px := px + 24;
    end;
    py := py + 24;
  end;
end;

procedure tpiswindow.zjisti(hrac: integer);
var
  hotovo: boolean;
  i, j  : integer;
begin
  hotovo := false;
  i := 0; j := 1;
  repeat
    inc(i);
    if i = 17 then
    begin
      i := 1;
      inc(j);
    end;
    if (j = 16) and (i = 16) then hotovo := true;
    if ((j <> 16) or (j <> 15) or (j <> 14) or (j <> 13)) and
      ((i <> 16) or (i <> 15) or (i <> 14) or (i <> 13)) and
      (hracipole[i, j] = hrac) then
    begin
      if not (j > 12) then
      if (hracipole[i, j+1] = hrac) and (hracipole[i, j+2] = hrac) and
        (hracipole[i, j+3] = hrac) and (hracipole[i, j+4] = hrac) then
      begin
        hracipole[i, j] := hrac + 2; hracipole[i, j+1] := hrac + 2;
        hracipole[i, j+2] := hrac + 2; hracipole[i, j+3] := hrac + 2;
        hracipole[i, j+4] := hrac + 2; hotovo := true; plocha(0); dabl := false;
        hra := false;
      end;
      if (hracipole[i+1, j] = hrac) and (hracipole[i+2, j] = hrac) and
        (hracipole[i+3, j] = hrac) and (hracipole[i+4, j] = hrac) then
      begin
        hracipole[i, j] := hrac + 2; hracipole[i+1, j] := hrac + 2;
        hracipole[i+2, j] := hrac + 2; hracipole[i+3, j] := hrac + 2;
        hracipole[i+4, j] := hrac + 2; hotovo := true; plocha(0); dabl := false;
        hra := false;
      end;
      if not (j > 12) and (j <> 1) then
      if (hracipole[i+1, j+1] = hrac) and (hracipole[i+2, j+2] = hrac) and
        (hracipole[i+3, j+3] = hrac) and (hracipole[i+4, j+4] = hrac) then
      begin
        hracipole[i, j] := hrac + 2; hracipole[i+1, j+1] := hrac + 2;
        hracipole[i+2, j+2] := hrac + 2; hracipole[i+3, j+3] := hrac + 2;
        hracipole[i+4, j+4] := hrac + 2; hotovo := true; plocha(0); dabl := false;
        hra := false;
      end;
      if ((i <> 1) and (i <> 2) and (i <> 3) and (i <> 4)) and (not(j > 12)) then
      begin
        if (hracipole[i-1, j+1] = hrac) and (hracipole[i-2, j+2] = hrac) and
          (hracipole[i-3, j+3] = hrac) and (hracipole[i-4, j+4] = hrac) then
        begin
          hracipole[i, j] := hrac + 2; hracipole[i-1, j+1] := hrac + 2;
          hracipole[i-2, j+2] := hrac + 2; hracipole[i-3, j+3] := hrac + 2;
          hracipole[i-4, j+4] := hrac + 2; hotovo := true; plocha(0); dabl := false;
          hra := false;
        end;
      end;
    end;
  until hotovo;
end;

procedure tpiswindow.vyber;
var
  vybx, vyby, i, j: integer;
begin
  if not hra then
  begin
    inc(pocitadlo);
    if pocitadlo = 2 then
    begin
      dabl := true;
      pocitadlo := 1;
      hra := true;
      for i := 1 to 16 do for j := 1 to 16 do hracipole[i, j] := 0;
      plocha(0);
    end;
  end;
  if dabl then
  begin
    vyby := 0;
    for j := 1 to 16 do
    begin
      vybx := 0;
      for i := 1 to 16 do
      begin
        if (mx > (vybx - 1)) and (mx < (vybx + 24)) then
        begin
          if (my > (vyby - 1)) and (my < (vyby + 24)) then
          begin
            if (hracipole[i, j] = 1) or (hracipole[i, j] = 2) then exit;
            hracipole[i, j] := 1;
            plocha(0);
            zjisti(1);
          end;
        end;
        vybx := vybx + 24;
      end;
      vyby := vyby + 24;
    end;
    if hra then odpovez;
    plocha(0);
    zjisti(2);
  end;
end;

procedure tpiswindow.odpovez;
var
  i, j  : integer;
  hotovo: boolean;
begin
  hotovo := false;
  zahral := false;
  i := 0; j := 1;
  premyslej(false); {..., neboj, ui ti neukousnu...}
  repeat
    inc(i);
    if i = 17 then
    begin
      i := 1;
      inc(j);
    end;
    if (j = 16) and (i = 16) then hotovo := true;
    if ((j <> 16) or (j <> 15) or (j <> 14) or (j <> 13)) and
      ((i <> 16) or (i <> 15) or (i <> 14) or (i <> 13)) then
    begin
      if i > 12 then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and
        (hracipole[i-1, j] = 0) and not zahral then
      begin
        hracipole[i-1, j] := 2;
        zahral := true;
      end;
      if i < 4 then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and
        (hracipole[i+2, j] = 0) and not zahral then
      begin
        hracipole[i+2, j] := 2;
        zahral := true;
      end;
      if j > 12 then
      if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and
        (hracipole[i, j-1] = 0) and not zahral then
      begin
        hracipole[i, j-1] := 2;
        zahral := true;
      end;
      if j < 4 then
      if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and
        (hracipole[i, j+2] = 0) and not zahral then
      begin
        hracipole[i, j+2] := 2;
        zahral := true;
      end;
      if (j > 12) or (i > 12) then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and
        (hracipole[i-1, j-1] = 0) and not zahral then
      begin
        hracipole[i-1, j-1] := 2;
        zahral := true;
      end;
      if (j < 4) or (i < 4) then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and
        (hracipole[i+2, j+2] = 0) and not zahral then
      begin
        hracipole[i+2, j+2] := 2;
        zahral := true;
      end;
      if ((j < 12) or (i > 12)) and (j <> 16) then
      if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and
        (hracipole[i-2, j+2] = 0) and not zahral then
      begin
        hracipole[i-2, j+2] := 2;
        zahral := true;
      end;
      if ((j > 12) or (i < 12)) and (j <> 16) then
      if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and
        (hracipole[i+1, j-1] = 0) and not zahral then
      begin
        hracipole[i+1, j-1] := 2;
        zahral := true;
      end;
      if (i > 3) and (i < 12) then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i+2, j] = 0) and
          not zahral then
        begin
          hracipole[i+2, j] := 2;
          zahral := true;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i-1, j] = 0) and
          not zahral then
        begin
          hracipole[i-1, j] := 2;
          zahral := true;
        end;
      end;
      if (j > 3) and (j < 12) then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j+2] = 0) and
          not zahral then
        begin
          hracipole[i, j+2] := 2;
          zahral := true;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j-1] = 0) and
          not zahral then
        begin
          hracipole[i, j-1] := 2;
          zahral := true;
        end;
      end;
      if (j < 12) and (i < 12) then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i+2, j+2] = 0) and
          not zahral then
        begin
          hracipole[i+2, j+2] := 2;
          zahral := true;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i-1, j-1] = 0) and
          not zahral then
        begin
          hracipole[i-1, j-1] := 2;
          zahral := true;
        end;
      end;
    end;
  until hotovo;
  if not zahral then premyslej(true); {Te u doopravdy nco vymysli!}
end;

procedure tpiswindow.premyslej(jak: boolean);
var
  i, j, tipx, tipy, maxc, maxp                                                          : integer;
  hotovo, mamvic, diry, triusebe, rozhodnuto, mamctyry, fintac, fintap, fintac2, fintap2: boolean;
begin
  if jak then
  begin
    hotovo := false;
    i := 0; j := 1;
    repeat
      inc(i);
      if i = 17 then
      begin
        i := 1;
        inc(j);
      end;
      if (i = 16) and (j = 16) then hotovo := true;
      if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 0) and not zahral then
      begin
        hracipole[i+1, j] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i-1, j] = 0) and not zahral then
      begin
        hracipole[i-1, j] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 0) and not zahral then
      begin
        hracipole[i, j+1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i, j-1] = 0) and not zahral then
      begin
        hracipole[i, j-1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 0) and not zahral then
      begin
        hracipole[i+1, j+1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i-1, j-1] = 0) and not zahral then
      begin
        hracipole[i-1, j-1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 0) and not zahral then
      begin
        hracipole[i-1, j+1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 2) and (hracipole[i+1, j-1] = 0) and not zahral then
      begin
        hracipole[i+1, j-1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 0) and not zahral then
      begin
        hracipole[i+1, j] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i-1, j] = 0) and not zahral then
      begin
        hracipole[i-1, j] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 0) and not zahral then
      begin
        hracipole[i, j+1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i, j-1] = 0) and not zahral then
      begin
        hracipole[i, j-1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 0) and not zahral then
      begin
        hracipole[i+1, j+1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i-1, j-1] = 0) and not zahral then
      begin
        hracipole[i-1, j-1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 0) and not zahral then
      begin
        hracipole[i-1, j+1] := 2;
        zahral := true;
      end;
      if (hracipole[i, j] = 1) and (hracipole[i+1, j-1] = 0) and not zahral then
      begin
        hracipole[i+1, j-1] := 2;
        zahral := true;
      end;
    until hotovo;
    if not zahral then
    begin
      hotovo := false;
      repeat
        i := random(16)+1;
        j := random(16)+1;
        if (j > 16) or (j < 1) or (i > 16) or (i < 1) then
        begin
          i := 1;
          j := 1;
        end;
        if hracipole[i, j] = 0 then hotovo := true;
      until hotovo;
      hracipole[i, j] := 2;
    end;
  end
  else
  begin
    hotovo := false; mamvic := false; diry := false; triusebe := false; rozhodnuto := false;
    mamctyry := false; fintac := false; fintap := false; fintac2 := false; fintap2 := false;
    i := 0; j := 1; maxc := 1; maxp := 1; tipx := 1; tipy := 1;
    repeat
      inc(i);
      if i = 17 then
      begin
        i := 1;
        inc(j);
      end;
      if (i = 16) and (j = 16) then hotovo := true;
      if i < 15 then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i+2, j] = 1) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxc := 3;
        if i < 14 then
        if (hracipole[i+3, j] = 0) then
        begin
          triusebe := true;
          tipx := i+3;
          tipy := j;
          rozhodnuto := true;
        end;
        if i <> 1 then
        if (hracipole[i-1, j] = 0) then
        begin
          triusebe := true;
          tipx := i-1;
          tipy := j;
          rozhodnuto := true;
        end;
      end;
      if j < 15 then
      if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j+2] = 1) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxc := 3;
        if j < 14 then
        if (hracipole[i, j+3] = 0) then
        begin
          triusebe := true;
          tipx := i;
          tipy := j+3;
          rozhodnuto := true;
        end;
        if j <> 1 then
        if (hracipole[i, j-1] = 0) then
        begin
          triusebe := true;
          tipx := i;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i < 15) and (j < 15) then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i+2, j+2] = 1) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxc := 3;
        if (i < 13) and (j < 13) then
        if (hracipole[i+3, j+3] = 0) then
        begin
          triusebe := true;
          tipx := i+3;
          tipy := j+3;
          rozhodnuto := true;
        end;
        if (i <> 1) and (j <> 1) then
        if (hracipole[i-1, j-1] = 0) then
        begin
          triusebe := true;
          tipx := i-1;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i > 2) and (j < 15) then
      if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and (hracipole[i-2, j+2] = 1) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxc := 3;
        if (i <> 16) and (j <> 1) then
        if (hracipole[i+1, j-1] = 0) then
        begin
          triusebe := true;
          tipx := i+1;
          tipy := j-1;
          rozhodnuto := true;
        end;
        if (i > 3) and (j < 14) then
        if (hracipole[i-3, j+3] = 0) then
        begin
          triusebe := true;
          tipx := i-3;
          tipy := j+3;
          rozhodnuto := true;
        end;
      end;
      if i < 15 then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 0) and (hracipole[i+2, j] = 1) and
        not triusebe and not mamctyry and not fintac and not fintap and not fintac2 and
        not fintap2 then
      begin
        tipx := i+1;
        tipy := j;
        rozhodnuto := true;
      end;
      if j < 15 then
      if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 0) and (hracipole[i, j+2] = 1) and
        not triusebe and not mamctyry and not fintac and not fintap and not fintac2 and
        not fintap2 then
      begin
        tipx := i;
        tipy := j+1;
        rozhodnuto := true;
      end;
      if (i < 15) and (j < 15) then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 0) and (hracipole[i+2, j+2] = 1) and
        not triusebe and not mamctyry and not fintac and not fintap and not fintac2 and
        not fintap2 then
      begin
        tipx := i+1;
        tipy := j+1;
        rozhodnuto := true;
      end;
      if (i > 2) and (j < 15) then
      if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 0) and (hracipole[i-2, j+2] = 1) and
        not triusebe and not mamctyry and not fintac and not fintap and not fintac2 and
        not fintap2 then
      begin
        tipx := i-1;
        tipy := j+1;
        rozhodnuto := true;
      end;
      if i < 15 then
      if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 2) and (hracipole[i+2, j] = 2) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxp := 3;
        if maxp >= maxc then mamvic := true;
        if i < 14 then
        if mamvic and (hracipole[i+3, j] = 0) then
        begin
          tipx := i+3;
          tipy := j;
          rozhodnuto := true;
        end;
        if i <> 1 then
        if mamvic and (hracipole[i-1, j] = 0) then
        begin
          tipx := i-1;
          tipy := j;
          rozhodnuto := true;
        end;
      end;
      if j < 15 then
      if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 2) and (hracipole[i, j+2] = 2) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxp := 3;
        if maxp >= maxc then mamvic := true;
        if j < 14 then
        if mamvic and (hracipole[i, j+3] = 0) then
        begin
          tipx := i;
          tipy := j+3;
          rozhodnuto := true;
        end;
        if j <> 1 then
        if mamvic and (hracipole[i, j-1] = 0) then
        begin
          tipx := i;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i < 15) and (i < 15) then
      if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 2) and (hracipole[i+2, j+2] = 2) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxp := 3;
        if maxp >= maxc then mamvic := true;
        if (j < 14) and (i < 14) then
        if mamvic and (hracipole[i+3, j+3] = 0) then
        begin
          tipx := i+3;
          tipy := j+3;
          rozhodnuto := true;
        end;
        if (j <> 1) and (i <> 1) then
        if mamvic and (hracipole[i-1, j-1] = 0) then
        begin
          tipx := i-1;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i > 2) and (j < 15) then
      if (hracipole[i ,j] = 2) and (hracipole[i-1, j+1] = 2) and (hracipole[i-2, j+2] = 2) and
        not mamctyry and not fintac and not fintap and not fintac2 and not fintap2 then
      begin
        maxp := 3;
        if maxp >= maxc then mamvic := true;
        if (i <> 16) and (j <> 1) then
        if mamvic and (hracipole[i+1, j-1] = 0) then
        begin
          tipx := i+1;
          tipy := j-1;
          rozhodnuto := true;
        end;
        if (i > 3) and (j < 14) then
        if mamvic and (hracipole[i-3, j+3] = 0) then
        begin
          tipx := i-3;
          tipy := j+3;
          rozhodnuto := true;
        end;
      end;
      if i < 15 then
      if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 0) and (hracipole[i+2, j] = 2) and
        not mamvic and not triusebe and not mamctyry and not fintac and not fintap and
        not fintac2 and not fintap2 then
      begin
        tipx := i+1;
        tipy := j;
        rozhodnuto := true;
      end;
      if j < 15 then
      if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 0) and (hracipole[i, j+2] = 2) and
        not mamvic and not triusebe and not mamctyry and not fintac and not fintap and
        not fintac2 and not fintap2 then
      begin
        tipx := i;
        tipy := j+1;
        rozhodnuto := true;
      end;
      if (i < 15) and (j < 15) then
      if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 0) and (hracipole[i+2, j+2] = 2) and
        not mamvic and not triusebe and not mamctyry and not fintac and not fintap and
        not fintac2 and not fintap2 then
      begin
        tipx := i+1;
        tipy := j+1;
        rozhodnuto := true;
      end;
      if (i > 2) and (j < 15) then
      if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 0) and (hracipole[i-2, j+2] = 2) and
        not mamvic and not triusebe and not mamctyry and not fintac and not fintap and
        not fintac2 and not fintap2 then
      begin
        tipx := i-1;
        tipy := j+1;
        rozhodnuto := true;
      end;
      if i < 13 then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i+2, j]= 1) and
        (hracipole[i+3, j] = 1) and not mamctyry then
      begin
        if i < 12 then
        if hracipole[i+4, j] = 0 then
        begin
          tipx := i+4;
          tipy := j;
          rozhodnuto := true;
        end;
        if i <> 1 then
        if hracipole[i-1, j] = 0 then
        begin
          tipx := i-1;
          tipy := j;
          rozhodnuto := true;
        end;
      end;
      if j < 13 then
      if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j+2] = 1) and
        (hracipole[i, j+3] = 1) and not mamctyry then
      begin
        if j < 12 then
        if hracipole[i, j+4] = 0 then
        begin
          tipx := i;
          tipy := j+4;
          rozhodnuto := true;
        end;
        if j <> 1 then
        if hracipole[i, j-1] = 0 then
        begin
          tipx := i;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i < 13) and (j < 13) then
      if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i+2, j+2] = 1) and
        (hracipole[i+3, j+3] = 1) and not mamctyry then
      begin
        if (i < 12) and (j < 12) then
        if hracipole[i+4, j+4] = 0 then
        begin
          tipx := i+4;
          tipy := j+4;
          rozhodnuto := true;
        end;
        if (i <> 1) and (j <> 1) then
        if hracipole[i-1, j-1] = 0 then
        begin
          tipx := i-1;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i > 3) and (j < 13) then
      if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and (hracipole[i-2, j+2] = 1) and
        (hracipole[i-3, j+3] = 1) and not mamctyry then
      begin
        if (i > 4) and (j < 12) then
        if hracipole[i-4, j+4] = 0 then
        begin
          tipx := i-4;
          tipy := j+4;
          rozhodnuto := true;
        end;
        if (i <> 16) and (j <> 1) then
        if hracipole[i+1, j-1] = 0 then
        begin
          tipx := i+1;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if i < 13 then
      if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 2) and (hracipole[i+2, j]= 2) and
        (hracipole[i+3, j] = 2) then
      begin
        if i < 12 then
        if hracipole[i+4, j] = 0 then
        begin
          mamctyry := true;
          tipx := i+4;
          tipy := j;
          rozhodnuto := true;
        end;
        if i <> 1 then
        if hracipole[i-1, j] = 0 then
        begin
          mamctyry := true;
          tipx := i-1;
          tipy := j;
          rozhodnuto := true;
        end;
      end;
      if j < 13 then
      if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 2) and (hracipole[i, j+2] = 2) and
        (hracipole[i, j+3] = 2) then
      begin
        if j < 12 then
        if hracipole[i, j+4] = 0 then
        begin
          mamctyry := true;
          tipx := i;
          tipy := j+4;
          rozhodnuto := true;
        end;
        if j <> 1 then
        if hracipole[i, j-1] = 0 then
        begin
          mamctyry := true;
          tipx := i;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i < 13) and (j < 13) then
      if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 2) and (hracipole[i+2, j+2] = 2) and
        (hracipole[i+3, j+3] = 2) then
      begin
        if (i < 12) and (j < 12) then
        if hracipole[i+4, j+4] = 0 then
        begin
          mamctyry := true;
          tipx := i+4;
          tipy := j+4;
          rozhodnuto := true;
        end;
        if (i <> 1) and (j <> 1) then
        if hracipole[i-1, j-1] = 0 then
        begin
          mamctyry := true;
          tipx := i-1;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i > 3) and (j < 13) then
      if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 2) and (hracipole[i-2, j+2] = 2) and
        (hracipole[i-3, j+3] = 2) then
      begin
        if (i > 4) and (j < 12) then
        if hracipole[i-4, j+4] = 0 then
        begin
          mamctyry := true;
          tipx := i-4;
          tipy := j+4;
          rozhodnuto := true;
        end;
        if (i <> 16) and (j <> 1) then
        if hracipole[i+1, j-1] = 0 then
        begin
          mamctyry := true;
          tipx := i+1;
          tipy := j-1;
          rozhodnuto := true;
        end;
      end;
      if (i < 12) and not mamctyry then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 0) and (hracipole[i+2, j] = 1) and
          (hracipole[i+3, j] = 1) and (hracipole[i+4, j] = 1) then
        begin
          fintac := true;
          tipx := i+1;
          tipy := j;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i+2, j] = 0) and
          (hracipole[i+3, j] = 1) and (hracipole[i+4, j] = 1) then
        begin
          fintac := true;
          tipx := i+2;
          tipy := j;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i+2, j] = 1) and
          (hracipole[i+3, j] = 0) and (hracipole[i+4, j] = 1) then
        begin
          fintac := true;
          tipx := i+3;
          tipy := j;
        end;
      end;
      if (j < 12) and not mamctyry then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 0) and (hracipole[i, j+2] = 1) and
          (hracipole[i, j+3] = 1) and (hracipole[i, j+4] = 1) then
        begin
          fintac := true;
          tipx := i;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j+2] = 0) and
          (hracipole[i, j+3] = 1) and (hracipole[i, j+4] = 1) then
        begin
          fintac := true;
          tipx := i;
          tipy := j+2;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j+2] = 1) and
          (hracipole[i, j+3] = 0) and (hracipole[i, j+4] = 1) then
        begin
          fintac := true;
          tipx := i;
          tipy := j+3;
        end;
      end;
      if (i < 12) and (j < 12) and not mamctyry then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 0) and (hracipole[i+2, j+2] = 1) and
          (hracipole[i+3, j+3] = 1) and (hracipole[i+4, j+4] = 1) then
        begin
          fintac := true;
          tipx := i+1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i+2, j+2] = 0) and
          (hracipole[i+3, j+3] = 1) and (hracipole[i+4, j+4] = 1) then
        begin
          fintac := true;
          tipx := i+2;
          tipy := j+2;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i+2, j+2] = 1) and
          (hracipole[i+3, j+3] = 0) and (hracipole[i+4, j+4] = 1) then
        begin
          fintac := true;
          tipx := i+3;
          tipy := j+3;
        end;
      end;
      if (i > 4) and (j < 12) and not mamctyry then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 0) and (hracipole[i-2, j+2] = 1) and
          (hracipole[i-3, j+3] = 1) and (hracipole[i-4, j+4] = 1) then
        begin
          fintac := true;
          tipx := i-1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and (hracipole[i-2, j+2] = 0) and
          (hracipole[i-3, j+3] = 1) and (hracipole[i-4, j+4] = 1) then
        begin
          fintac := true;
          tipx := i-2;
          tipy := j+2;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and (hracipole[i-2, j+2] = 1) and
          (hracipole[i-3, j+3] = 0) and (hracipole[i-4, j+4] = 1) then
        begin
          fintac := true;
          tipx := i-3;
          tipy := j+3;
        end;
      end;
      if i < 12 then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 0) and (hracipole[i+2, j] = 2) and
          (hracipole[i+3, j] = 2) and (hracipole[i+4, j] = 2) then
        begin
          fintap := true;
          tipx := i+1;
          tipy := j;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 2) and (hracipole[i+2, j] = 0) and
          (hracipole[i+3, j] = 2) and (hracipole[i+4, j] = 2) then
        begin
          fintap := true;
          tipx := i+2;
          tipy := j;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 2) and (hracipole[i+2, j] = 2) and
          (hracipole[i+3, j] = 0) and (hracipole[i+4, j] = 2) then
        begin
          fintap := true;
          tipx := i+3;
          tipy := j;
        end;
      end;
      if j < 12 then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 0) and (hracipole[i, j+2] = 2) and
          (hracipole[i, j+3] = 2) and (hracipole[i, j+4] = 2) then
        begin
          fintap := true;
          tipx := i;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 2) and (hracipole[i, j+2] = 0) and
          (hracipole[i, j+3] = 2) and (hracipole[i, j+4] = 2) then
        begin
          fintap := true;
          tipx := i;
          tipy := j+2;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 2) and (hracipole[i, j+2] = 2) and
          (hracipole[i, j+3] = 0) and (hracipole[i, j+4] = 2) then
        begin
          fintap := true;
          tipx := i;
          tipy := j+3;
        end;
      end;
      if (i < 12) and (j < 12) then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 0) and (hracipole[i+2, j+2] = 2) and
          (hracipole[i+3, j+3] = 2) and (hracipole[i+4, j+4] = 2) then
        begin
          fintap := true;
          tipx := i+1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 2) and (hracipole[i+2, j+2] = 0) and
          (hracipole[i+3, j+3] = 2) and (hracipole[i+4, j+4] = 2) then
        begin
          fintap := true;
          tipx := i+2;
          tipy := j+2;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 2) and (hracipole[i+2, j+2] = 2) and
          (hracipole[i+3, j+3] = 0) and (hracipole[i+4, j+4] = 2) then
        begin
          fintap := true;
          tipx := i+3;
          tipy := j+3;
        end;
      end;
      if (i > 4) and (j < 12) then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 0) and (hracipole[i-2, j+2] = 2) and
          (hracipole[i-3, j+3] = 2) and (hracipole[i-4, j+4] = 2) then
        begin
          fintap := true;
          tipx := i-1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 2) and (hracipole[i-2, j+2] = 0) and
          (hracipole[i-3, j+3] = 2) and (hracipole[i-4, j+4] = 2) then
        begin
          fintap := true;
          tipx := i-2;
          tipy := j+2;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 2) and (hracipole[i-2, j+2] = 2) and
          (hracipole[i-3, j+3] = 0) and (hracipole[i-4, j+4] = 2) then
        begin
          fintap := true;
          tipx := i-3;
          tipy := j+3;
        end;
      end;
      if (i < 13) and not mamctyry and not fintap and not fintac then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 0) and (hracipole[i+2, j] = 1) and
          (hracipole[i+3, j] = 1) then
        begin
          fintac2 := true;
          tipx := i+1;
          tipy := j;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j] = 1) and (hracipole[i+2, j] = 0) and
          (hracipole[i+3, j] = 1) then
        begin
          fintac2 := true;
          tipx := i+2;
          tipy := j;
        end;
      end;
      if (j < 13) and not mamctyry and not fintap and not fintac then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 0) and (hracipole[i, j+2] = 1) and
          (hracipole[i, j+3] = 1) then
        begin
          fintac2 := true;
          tipx := i;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i, j+1] = 1) and (hracipole[i, j+2] = 0) and
          (hracipole[i, j+3] = 1) then
        begin
          fintac2 := true;
          tipx := i;
          tipy := j+2;
        end;
      end;
      if (i < 13) and (j < 13) and not mamctyry and not fintac and not fintap then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 0) and (hracipole[i+2, j+2] = 1) and
          (hracipole[i+3, j+3] = 1) then
        begin
          fintac2 := true;
          tipx := i+1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i+1, j+1] = 1) and (hracipole[i+2, j+2] = 0) and
          (hracipole[i+3, j+3] = 1) then
        begin
          fintac2 := true;
          tipx := i+2;
          tipy := j+2;
        end;
      end;
      if (i > 3) and (j < 13) and not mamctyry and not fintac and not fintap then
      begin
        if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 0) and (hracipole[i-2, j+2] = 1) and
          (hracipole[i-3, j+3] = 1) then
        begin
          fintac2 := true;
          tipx := i-1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 1) and (hracipole[i-1, j+1] = 1) and (hracipole[i-2, j+2] = 0) and
          (hracipole[i-3, j+3] = 1) then
        begin
          fintac2 := true;
          tipx := i-2;
          tipy := j+2;
        end;
      end;
      if (i < 13) and not mamctyry and not fintap and not fintac and not fintac2 then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 0) and (hracipole[i+2, j] = 2) and
          (hracipole[i+3, j] = 2) then
        begin
          fintap2 := true;
          tipx := i+1;
          tipy := j;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i+1, j] = 2) and (hracipole[i+2, j] = 0) and
          (hracipole[i+3, j] = 2) then
        begin
          fintap2 := true;
          tipx := i+2;
          tipy := j;
        end;
      end;
      if (j < 13) and not mamctyry and not fintap and not fintac and not fintac2 then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 0) and (hracipole[i, j+2] = 2) and
          (hracipole[i, j+3] = 2) then
        begin
          fintap2 := true;
          tipx := i;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i, j+1] = 2) and (hracipole[i, j+2] = 0) and
          (hracipole[i, j+3] = 2) then
        begin
          fintap2 := true;
          tipx := i;
          tipy := j+2;
        end;
      end;
      if (i < 13) and (j < 13) and not mamctyry and not fintac and not fintap and not fintac2 then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 0) and (hracipole[i+2, j+2] = 2) and
          (hracipole[i+3, j+3] = 2) then
        begin
          fintap2 := true;
          tipx := i+1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i+1, j+1] = 2) and (hracipole[i+2, j+2] = 0) and
          (hracipole[i+3, j+3] = 2) then
        begin
          fintap2 := true;
          tipx := i+2;
          tipy := j+2;
        end;
      end;
      if (i > 3) and (j < 13) and not mamctyry and not fintac and not fintap and not fintac2 then
      begin
        if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 0) and (hracipole[i-2, j+2] = 2) and
          (hracipole[i-3, j+3] = 2) then
        begin
          fintap2 := true;
          tipx := i-1;
          tipy := j+1;
        end;
        if (hracipole[i, j] = 2) and (hracipole[i-1, j+1] = 2) and (hracipole[i-2, j+2] = 0) and
          (hracipole[i-3, j+3] = 2) then
        begin
          fintap2 := true;
          tipx := i-2;
          tipy := j+2;
        end;
      end;
    until hotovo;
    if rozhodnuto then
    begin
      hracipole[tipx, tipy] := 2;
      zahral := true;
    end;
  end;
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(ppiswindow, init(nil, 'Pikvorky - Filip Loueck'));
end;

var
  app: tapp;
begin
  app.init('PIKVORKY');
  app.run;
  app.done;
end.