program Puzzle;
{$r puzzle.res}
uses
  wintypes, winprocs, owindows, odialogs, strings;
const
  cm_nova = 101;
  cm_konec = 102;
  cm_oprog = 103;
  cm_jak = 104;
type
  ppuzwindow = ^tpuzwindow;
  tpuzwindow = object(twindow)
    puzzle, pozadi, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14,
    a15, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, zadny: hbitmap;
    kursor: hcursor;
    zacatek, hra: boolean;
    hraobr, cislo, mx, my: integer;
    hadpole: array[1..16] of integer;
    zappole: array[1..16] of boolean;
    constructor init(aparent: pwindowsobject; atitle: pchar);
    function canclose: boolean; virtual;
    procedure obraz(dc: hdc; x, y, bitmap: hbitmap);
    procedure getwindowclass(var wndclass: twndclass); virtual;
    procedure paint(obrdc: hdc; var paintinfo: tpaintstruct); virtual;
    procedure setupwindow; virtual;
    procedure wmlbuttondown(var msg: tmessage); virtual wm_lbuttondown;
    procedure wmrbuttondown(var msg: tmessage); virtual wm_rbuttondown;
    procedure plocha(dc: hdc);
    procedure obrazky(dc: hdc; ox, oy: integer);
    procedure priklad;
    procedure novahra;
    procedure hadctver;
    procedure naprav;
    procedure vyber;
    procedure konhry;
    procedure cmnova(var msg: tmessage); virtual cm_first + cm_nova;
    procedure cmkonec(var msg: tmessage); virtual cm_first + cm_konec;
    procedure cmoprog(var msg: tmessage); virtual cm_first + cm_oprog;
    procedure cmjak(var msg: tmessage); virtual cm_first + cm_jak;
  end;
  tapp = object(tapplication)
    procedure initmainwindow; virtual;
  end;

constructor tpuzwindow.init(aparent: pwindowsobject; atitle: pchar);
begin
  twindow.init(aparent, atitle);
  attr.w := 436; {Dlka}
  attr.h := 474; {Vka}
  attr.style := ws_caption or ws_sysmenu or ws_minimizebox;
  randomize;
end;

function tpuzwindow.canclose: boolean;
begin
  canclose := true;
  if messagebox(hwindow, 'Opravdu chcete hru ukonit?', 'Puzzle', mb_YesNo or
  mb_IconQuestion) <> id_Yes then canclose := false;
end;

procedure tpuzwindow.obraz(dc: hdc; x, y, bitmap: hbitmap);
var
  memdc : hdc;
  bm    : tbitmap;
  madedc: boolean;
begin
  if dc = 0 then
  begin
    dc := getdc(hwindow);
    madedc := true;
  end
  else
    madedc := false;
  memdc := createcompatibledc(dc);
  selectobject(memdc, bitmap);
  getobject(puzzle, sizeof(bm), @bm);
  bitblt(dc, x, y, bm.bmwidth, bm.bmheight, memdc, 0, 0, srccopy);
  deletedc(memdc);
  if madedc then releasedc(hwindow, dc);
end;

procedure tpuzwindow.getwindowclass(var wndclass: twndclass);
begin
  twindow.getwindowclass(wndclass);
  kursor := loadcursor(hinstance, 'KURSOR');
  wndclass.style := 0;
  wndclass.hcursor := kursor;
  wndclass.hicon := loadicon(hinstance, 'IKONA');
  wndclass.lpszmenuname := 'MENU';
end;

procedure tpuzwindow.paint(obrdc: hdc; var paintinfo: tpaintstruct);
begin
  plocha(obrdc);
  obraz(obrdc, 292, 83, puzzle);
  obraz(obrdc, 74, 292, puzzle);
  if hra then
  begin
    priklad;
    hadctver;
  end;
  if zacatek then
  begin
    zacatek := false;
    novahra;
    messagebox(hwindow, 'Vtejte ve he Puzzle!', 'Puzzle', mb_Ok or mb_IconInformation);
  end;
end;

procedure tpuzwindow.setupwindow;
var
  i: integer;
begin
  puzzle := loadbitmap(hinstance, 'PUZZLE');
  pozadi := loadbitmap(hinstance, 'POZADI');
  zadny := loadbitmap(hinstance, 'ZADNY');
  a1 := loadbitmap(hinstance, 'A1'); a2 := loadbitmap(hinstance, 'A2');
  a3 := loadbitmap(hinstance, 'A3'); a4 := loadbitmap(hinstance, 'A4');
  a5 := loadbitmap(hinstance, 'A5'); a6 := loadbitmap(hinstance, 'A6');
  a7 := loadbitmap(hinstance, 'A7'); a8 := loadbitmap(hinstance, 'A8');
  a9 := loadbitmap(hinstance, 'A9'); a10 := loadbitmap(hinstance, 'A10');
  a11 := loadbitmap(hinstance, 'A11'); a12 := loadbitmap(hinstance, 'A12');
  a13 := loadbitmap(hinstance, 'A13'); a14 := loadbitmap(hinstance, 'A14');
  a15 := loadbitmap(hinstance, 'A15');
  b1 := loadbitmap(hinstance, 'B1'); b2 := loadbitmap(hinstance, 'B2');
  b3 := loadbitmap(hinstance, 'B3'); b4 := loadbitmap(hinstance, 'B4');
  b5 := loadbitmap(hinstance, 'B5'); b6 := loadbitmap(hinstance, 'B6');
  b7 := loadbitmap(hinstance, 'B7'); b8 := loadbitmap(hinstance, 'B8');
  b9 := loadbitmap(hinstance, 'B9'); b10 := loadbitmap(hinstance, 'B10');
  b11 := loadbitmap(hinstance, 'B11'); b12 := loadbitmap(hinstance, 'B12');
  b13 := loadbitmap(hinstance, 'B13'); b14 := loadbitmap(hinstance, 'B14');
  b15 := loadbitmap(hinstance, 'B15');
  zacatek := true;
end;

procedure tpuzwindow.wmlbuttondown(var msg: tmessage);
begin
  mx := msg.lparamlo;
  my := msg.lparamhi;
  vyber;
end;

procedure tpuzwindow.wmrbuttondown(var msg: tmessage);
begin
  mx := msg.lparamlo;
  my := msg.lparamhi;
  vyber;
end;

procedure tpuzwindow.plocha(dc: hdc);
var
  i, j, px, py: integer;
begin
  py := 0;
  for i := 1 to 9 do
  begin
    px := 0;
    for j := 1 to 9 do
    begin
      obraz(dc, px, py, pozadi);
      px := px + 50;
    end;
    py := py + 50;
  end;
end;

procedure tpuzwindow.obrazky(dc: hdc; ox, oy: integer);
begin
  if hraobr = 1 then
  begin
    case cislo of
      1: obraz(dc, ox, oy, a1);
      2: obraz(dc, ox, oy, a2);
      3: obraz(dc, ox, oy, a3);
      4: obraz(dc, ox, oy, a4);
      5: obraz(dc, ox, oy, a5);
      6: obraz(dc, ox, oy, a6);
      7: obraz(dc, ox, oy, a7);
      8: obraz(dc, ox, oy, a8);
      9: obraz(dc, ox, oy, a9);
      10: obraz(dc, ox, oy, a10);
      11: obraz(dc, ox, oy, a11);
      12: obraz(dc, ox, oy, a12);
      13: obraz(dc, ox, oy, a13);
      14: obraz(dc, ox, oy, a14);
      15: obraz(dc, ox, oy, a15);
      16: obraz(dc, ox, oy, zadny);
    end;
  end
  else
  begin
    case cislo of
      1: obraz(dc, ox, oy, b1);
      2: obraz(dc, ox, oy, b2);
      3: obraz(dc, ox, oy, b3);
      4: obraz(dc, ox, oy, b4);
      5: obraz(dc, ox, oy, b5);
      6: obraz(dc, ox, oy, b6);
      7: obraz(dc, ox, oy, b7);
      8: obraz(dc, ox, oy, b8);
      9: obraz(dc, ox, oy, b9);
      10: obraz(dc, ox, oy, b10);
      11: obraz(dc, ox, oy, b11);
      12: obraz(dc, ox, oy, b12);
      13: obraz(dc, ox, oy, b13);
      14: obraz(dc, ox, oy, b14);
      15: obraz(dc, ox, oy, b15);
      16: obraz(dc, ox, oy, zadny);
    end;
  end;
end;

procedure tpuzwindow.priklad;
var
  i, j, px, py: integer;
begin
  cislo := 0;
  py := 0;
  for i := 1 to 4 do
  begin
    px := 0;
    for j := 1 to 4 do
    begin
      inc(cislo);
      obrazky(0, px, py);
      px := px + 50;
    end;
    py := py + 50;
  end;
end;

procedure tpuzwindow.novahra;
var
  hotovo: boolean;
  i, nah:integer;
begin
  hraobr := random(2);
  hra := true;
  priklad;
  for i := 1 to 16 do hadpole[i] := 0;
  for i := 1 to 16 do zappole[i] := false;
  for i := 1 to 16 do
  begin
    hotovo := false;
    repeat
      nah := random(16) + 1;
      if (nah < 1) or (nah > 16) then naprav;
      if not zappole[nah] then hotovo := true;
    until hotovo;
    hadpole[i] := nah;
    zappole[nah] := true;
  end;
  hadctver;
end;

procedure tpuzwindow.hadctver;
var
  i, j, n, px, py: integer;
begin
  n := 0;
  py := 234;
  for i := 1 to 4 do
  begin
    px := 234;
    for j := 1 to 4 do
    begin
      inc(n);
      cislo := hadpole[n];
      obrazky(0, px, py);
      px := px + 50;
    end;
    py := py + 50;
  end;
end;

procedure tpuzwindow.naprav;
begin
  messagebox(hwindow, 'Program zjistil, e udlal chybu, a proto ji naprav.', 'Puzzle',
    mb_Ok or mb_IconExclamation);
  novahra;
end;

procedure tpuzwindow.vyber;
var
  vybx, vyby, i, j, m: integer;
  temp, konec        : boolean;
begin
  if (mx > 291) and (mx < 362) then
  begin
    if (my > 82) and (my < 153) then
    begin
      messagebeep(mb_Ok);
      novahra;
    end;
  end;
  if (mx > 73) and (mx < 144) then
  begin
    if (my > 291) and (my < 362) then
    begin
      messagebeep(mb_Ok);
      novahra;
    end;
  end;
  konec := false;
  temp := false;
  vyby := 234;
  m := 0;
  for j := 1 to 4 do
  begin
    vybx := 234;
    for i := 1 to 4 do
    begin
      inc(m);
      if (mx > (vybx - 1)) and (mx < (vybx + 50)) then
      begin
        if (my > (vyby - 1)) and (my < (vyby + 50)) then
        begin
          if hadpole[m] = 16 then exit;
          if j = 1 then
          begin
            if hadpole[m+4] = 16 then
            begin
              hadpole[m+4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (i <> 1) and (hadpole[m-1] = 16) then
            begin
              hadpole[m-1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (i <> 4) and (hadpole[m+1] = 16) then
            begin
              hadpole[m+1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            temp := true;
          end;
          if i = 1 then
          begin
            if hadpole[m+1] = 16 then
            begin
              hadpole[m+1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (j <> 1) and (hadpole[m-4] = 16) then
            begin
              hadpole[m-4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (j <> 4) and (hadpole[m+4] = 16) then
            begin
              hadpole[m+4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            temp := true;
          end;
          if j = 4 then
          begin
            if hadpole[m-4] = 16 then
            begin
              hadpole[m-4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (i <> 1) and (hadpole[m-1] = 16) then
            begin
              hadpole[m-1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (i <> 4) and (hadpole[m+1] = 16) then
            begin
              hadpole[m+1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            temp := true;
          end;
          if i = 4 then
          begin
            if hadpole[m-1] = 16 then
            begin
              hadpole[m-1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (j <> 1) and (hadpole[m-4] = 16) then
            begin
              hadpole[m-4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if (j <> 4) and (hadpole[m+4] = 16) then
            begin
              hadpole[m+4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            temp := true;
          end;
          if not temp then
          begin
            if hadpole[m-4] = 16 then
            begin
              hadpole[m-4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if hadpole[m+4] = 16 then
            begin
              hadpole[m+4] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if hadpole[m-1] = 16 then
            begin
              hadpole[m-1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
            if hadpole[m+1] = 16 then
            begin
              hadpole[m+1] := hadpole[m];
              hadpole[m] := 16;
              hadctver;
            end;
          end;
        end;
      end;
      vybx := vybx + 50;
    end;
    vyby := vyby + 50;
  end;
  temp := false;
  i := 0;
  repeat
    inc(i);
    if hadpole[i] <> i then
    begin
      konec := false;
      temp := true;
    end;
    if i = 16 then
    begin
      temp := true;
      konec := true;
    end;
  until temp;
  if konec then konhry;
end;

procedure tpuzwindow.konhry;
begin
  if messagebox(hwindow, 'Konec hry. Chcete hrt novou hru?', 'Puzzle',
    mb_YesNo or mb_IconQuestion) = id_Yes then novahra
  else
  begin
    hra := false;
    plocha(0);
    obraz(0, 292, 83, puzzle);
    obraz(0, 74, 292, puzzle);
  end;
end;

procedure tpuzwindow.cmnova(var msg: tmessage);
begin
  novahra;
end;

procedure tpuzwindow.cmkonec(var msg: tmessage);
begin
  closewindow;
end;

procedure tpuzwindow.cmoprog(var msg: tmessage);
begin
  application^.execdialog(new(pdialog, init(@self, 'OPROG')));
end;

procedure tpuzwindow.cmjak(var msg: tmessage);
begin
  application^.execdialog(new(pdialog, init(@self, 'JAKHRAT')));
end;

procedure tapp.initmainwindow;
begin
  mainwindow := new(ppuzwindow, init(nil, 'Puzzle'));
end;

procedure naplochu(var r: trect);
var
  bm: hbitmap;
  dc, memdc: hdc;
  bitinfo: tbitmap;
begin
  dc := getdc(0);
  memdc := createcompatibledc(dc);
  bm := loadbitmap(hinstance, 'PUZZLE');
  getobject(bm, sizeof(bitinfo), @bitinfo);
  bm := selectobject(memdc, bm);
  r.left := getdevicecaps(dc,horzres) div 2 - bitinfo.bmwidth div 2;
  r.top := getdevicecaps(dc,vertres) div 2 - bitinfo.bmheight div 2;
  bitblt(dc, r.left, r.top, bitinfo.bmwidth, bitinfo.bmheight,
         memdc, 0, 0, srccopy);
  deleteobject(selectobject(memdc, bm));
  deletedc(memdc);
  releasedc(0, dc);
  r.right := r.left + bitinfo.bmwidth;
  r.bottom := r.top + bitinfo.bmheight;
end;

var
  app: tapp;
  r  : trect;
begin
  naplochu(r);
  app.init('PUZZLE');
  invalidaterect(0, @r, true);
  app.run;
  app.done;
end.