program _InfoBMP_;
type
  tbmphlavicka = record
                   znacka    : array[0..1] of char; {Znacka BMP souboru}
                   velikost  : longint;             {Velikost BMP souboru}
                   reserved  : longint;             {Reserved}
                   velikosthl: longint;             {Velikost hlavicky}
                   velikostin: longint;             {Velikost informaci za hlavickou}
                   sirka     : longint;             {Sirka obrazku}
                   vyska     : longint;             {Vyska obrazku}
                   pocbitrov : word;                {Pocet bitovych rovin}
                   bits      : word;                {Pocet bitu na barvu}
                   komprimace: longint;             {Komprimace}
                   velobr    : longint;             {Velikost obrazku}
                   rx        : longint;             {Rastr v ose x}
                   ry        : longint;             {Rastr v ose y}
                   used, impo: longint;             {Pouzite a dulezite barvy}
                 end;

var
  BMPsoubor: file;
  hlavicka : tbmphlavicka;
  i, j     : byte;
  tajnytxt : string;
  paleta   : array[0..3] of byte;                   {Paleta barev; BGRI}

begin
  if paramcount = 0 then
  begin
    writeln('Pouziti programu: INFOBMP nazev_souboru');
    writeln('  - zobrazi vlastnosti souboru (nazev souboru i s priponou)');
    writeln('  - zobrazuje pouze informace o BMP obrazcich');
    writeln;
    exit;
  end;
  tajnytxt := '';
  assign(BMPsoubor, paramstr(1));
  {$i-}
  reset(BMPsoubor, 1);
  {$i+}
  if ioresult <> 0 then
  begin
    writeln('ERR: Zadany soubor (', paramstr(1), ') je poskozeny nebo neexistuje.');
    halt;
  end;
  {$i-}
  blockread(BMPsoubor, hlavicka, sizeof(hlavicka)); {Nacteni hlavicky}
  {$i+}
  if ioresult <> 0 then
  begin
    writeln('ERR: Nelze precist zahlavi souboru (', paramstr(1), ').');
    halt;
  end;
  if (hlavicka.bits in [1, 2, 4, 8]) then
  begin
    if hlavicka.used <> 0 then j := hlavicka.used - 1
    else
    begin
      case hlavicka.bits of
        1: j := 1;
        2: j := 3;
        4: j := 15;
        8: j := 255;
      end;
    end;
  end;
  for i := 0 to j do
  begin
    {$i-}
    blockread(BMPsoubor, paleta, sizeof(paleta));
    {$i+}
    if ioresult <> 0 then
    begin
      tajnytxt := '';
      writeln('ERR: Nepodarilo se nacist paletu barev.');
      break;
    end;
    if (paleta[3] in [32..127]) then
      tajnytxt := tajnytxt + chr(paleta[3]);
  end;
  close(BMPsoubor);
  writeln('Filip Louzecky, program INFOBMP');
  writeln;
  writeln('Nazev souboru                   : ', paramstr(1));
  writeln('Velikost BMP souboru            : ', hlavicka.velikost);
  writeln('Velikost hlavicky               : ', hlavicka.velikosthl);
  writeln('Velikost info za hlavickou      : ', hlavicka.velikostin);
  writeln('Sirka obrazku                   : ', hlavicka.sirka);
  writeln('Vyska obrazku                   : ', hlavicka.vyska);
  writeln('Pocet bitovych rovin            : ', hlavicka.pocbitrov);
  writeln('Pocet bitu na pixel             : ', hlavicka.bits);
  writeln('Komprimace (0 - neni)           : ', hlavicka.komprimace);
  writeln('Velikost obrazku (s * v / bpp)  : ', hlavicka.velobr);
  writeln('Rastr v ose x                   : ', hlavicka.rx);
  writeln('Rastr v ose y                   : ', hlavicka.ry);
  writeln('Pocet pouzitych barev (0 - vse) : ', hlavicka.used);
  writeln('Pocet dulezitych barev (0 - vse): ', hlavicka.impo);
  if tajnytxt <> '' then
    writeln(chr(13), 'Obrazek obsahuje tajny text: ', tajnytxt);
  writeln;
end.