program _ShowBMP_;
uses
  crt, graph; {Budeme pouzivat jednotky Crt a Graph, blizsi info v dokumentaci k Borland Pascalu.}

const
  prizn: array[0..7] of byte = (128, 64, 32, 16, 8, 4, 2, 1); {Masky pro cernobile obrazky.}

type
  tbmphlavicka = record
                   znacka    : array[0..1] of char; {BM}
                   velikost  : longint;             {Velikost BMP souboru}
                   reserved  : longint;             {Reserved}
                   velikosthl: longint;             {Velikost hlavicky}
                   velikostin: longint;             {Velikost informaci za hlavickou}
                   sirka     : longint;             {Sirka obrazku}
                   vyska     : longint;             {Vyska obrazku}
                   pocbitrov : word;                {Pocet bitovych rovin}
                   bits      : word;                {Pocet bitu na barvu}
                   komprimace: longint;             {Komprimace}
                   velobr    : longint;             {Velikost obrazku}
                   rx        : longint;             {Rastr v ose x}
                   ry        : longint;             {Rastr v ose y}
                   used, impo: longint;             {Pocet pouzitych a dulezitych barev}
                 end;
  str79 = string[79]; {Retezec obsahujici nazev souboru}
  tpixelBGR = record {Definice pixelu pro 24bitove obrazky}
                blue, green, red: byte;
              end;

var
  gd, gm, errcode, sx, sy : integer;
  BMPpaleta               : array[0..3] of byte;    {Paleta techto obrazku ma 4 polozky - B, G, R a I}
  BMPsoubor               : file;                   {Soubor s obrazkem}
  hlavicka                : tbmphlavicka;           {Hlavicka souboru}
  i, pix, poc, pom, dop, j,
  pix16                   : byte;
  x, y                    : longint;
  list                    : array[1..255] of str79; {Seznam souboru k zobrazeni}
  klav                    : char;
  ft                      : text;                   {Promenna pro textovy soubor LIST.TXT}
  pixbgr                  : tpixelBGR;
  bit24                   : boolean;                {Pomocna promenna, podle
  ni se urcuje jestli se bude znovu generovat paleta pro 24 bitovy obrazek}

{$F+}
function detectVGA256 : integer;
var
  dd, sm: integer;
begin
  detectgraph(dd, sm);
  if (dd = VGA) or (dd = MCGA) then detectVGA256 := 2
  else detectVGA256 := grError;
end;
{$F-}

begin
  if paramcount = 0 then
  begin
    writeln('Pouziti programu: SHOWBMP nazev_souboru');
    writeln('  - zobrazi Vami zadany soubor (nazev souboru i s priponou)');
    writeln('  - zobrazuje pouze nekomprimovane BMP obrazky (1 bit, 4 bity,');
    writeln('    8 bitu a 24 bity) pri maximalnim rozliseni 640 * 480 bodu');
    writeln('  - obrazky s vetsim rozlisenim nebudou zobrazeny cele');
    writeln('nebo: SHOWBMP --f');
    writeln('  - bude ve svem adresari hledat soubor LIST.TXT, ve kterem');
    writeln('    jsou vypsany soubory, jez se maji zobrazit (na kazdem');
    writeln('    radku jmeno jednoho souboru); po stisknuti klavesy se');
    writeln('    prejde k nasledujicimu souboru, po stisku ESC se program');
    writeln('    ukonci, trebaze jeste nebyly zobrazeny vsechny soubory');
    writeln('  - soubor LIST.TXT muze obsahovat pouze 255 nazvu');
    exit;
  end;
  if paramstr(1) = '--f' then
  begin
    assign(ft, 'LIST.TXT');
    {$i-}
    reset(ft);
    {$i+}
    if ioresult <> 0 then
    begin
      writeln('Nelze nacist soubor LIST.TXT.');
      halt;
    end;
    poc := 0;
    while not eof(ft) do
    begin
      poc := poc + 1;
      readln(ft, list[poc]);
    end;
    close(ft);
  end
  else
  begin
    poc := 1;
    list[poc] := paramstr(1);
  end;
  bit24 := false;
  directvideo := false;
  gd := installuserdriver('SVGA256', @detectVGA256);
  gd := detect;
  initgraph(gd, gm, '');
  errcode := graphresult;
  if errcode and $80 = $80 then errcode := errcode or $ff00;
  if errcode <> grOk then
  begin
    writeln('Chyba pri inicializaci grafiky (640x480x256).');
    halt;
  end;
  for pom := 1 to poc do
  begin
    assign(BMPsoubor, list[pom]);
    {$i-}
    reset(BMPsoubor, 1);
    {$i+}
    if ioresult <> 0 then
    begin
      closegraph;
      writeln('Zadany soubor je poskozeny nebo neexistuje.');
      halt;
    end;
    {$i-}
    blockread(BMPsoubor, hlavicka, sizeof(hlavicka)); {Nacteni hlavicky}
    {$i+}
    if ioresult <> 0 then
    begin
      closegraph;
      writeln('Nelze precist zahlavi souboru.');
      halt;
    end;
    if not (hlavicka.bits in [1, 4, 8, 24]) then
    begin
      closegraph;
      writeln('Tento program zobrazuje pouze obrazky, ktere maji 1, 4, 8 nebo 24 bitu.');
      halt;
    end;
    if hlavicka.komprimace <> 0 then
    begin
      closegraph;
      writeln('Tento soubor je komprimovany.');
      halt;
    end;
    if hlavicka.used <> 0 then j := hlavicka.used - 1
    else
    begin
      case hlavicka.bits of
        1: j := 1;
        4: j := 15;
        8: j := 255;
      else
        j := 255;
      end;
    end;
    if hlavicka.bits in [1, 4, 8] then
      for i := 0 to j do {Nacteni palety}
      begin
        {$i-}
        blockread(BMPsoubor, BMPpaleta, sizeof(BMPpaleta));
        {$i+}
        if ioresult <> 0 then
        begin
          closegraph;
          writeln('Chyba pri nacitani palety.');
          halt;
        end;
        setRGBpalette(i, BMPpaleta[2] div 4, BMPpaleta[1] div 4, BMPpaleta[0] div 4);
      end;
    if (hlavicka.bits = 24) and not bit24 then
    begin
      for i := 0 to j do {Vytvoreni palety}
        setRGBpalette(i, (i and 7) * 8 + 7, ((i shr 3) and 7) * 8 + 7, (i shr 6) * 16 + 15);
      bit24 := true; {Nebudeme vytvaret paletu nekolikrat po sobe}
    end 
    else 
      if hlavicka.bits <> 24 then bit24 := false; 
    if hlavicka.sirka <= 640 then sx := 320 - hlavicka.sirka div 2 
    else sx := 0; 
    if hlavicka.vyska <= 480 then sy := 239 + hlavicka.vyska div 2 
    else sy := 479; 
    case hlavicka.bits of 
      1    : begin 
               if hlavicka.sirka mod 8 <> 0 then 
                 dop := ((hlavicka.sirka + 7) div 8 * 8) - hlavicka.sirka 
               else dop := 0; 
               if ((hlavicka.sirka + dop) div 8) mod 4 <> 0 then 
                 dop := dop + ((((hlavicka.sirka + dop) div 8 + 3) 
                   div 4 * 4) - ((hlavicka.sirka + dop) div 8)) * 8; 
             end; 
      4    : begin 
               if (hlavicka.sirka div 2) mod 4 <> 0 then 
                 dop := ((((hlavicka.sirka div 2) + 3) div 4 * 4) - 
                   (hlavicka.sirka div 2)) * 2 
               else dop := 0; 
               if hlavicka.sirka mod 2 <> 0 then 
                 dop := dop - (((hlavicka.sirka + 1) div 2 * 2) - 
                   hlavicka.sirka); 
             end; 
      8, 24: if hlavicka.sirka mod 4 <> 0 then 
               dop := ((hlavicka.sirka + 3) div 4 * 4) - hlavicka.sirka 
             else dop := 0; 
    end; 
    j := 0; 
    for y := 0 to hlavicka.vyska - 1 do 
      for x := 0 to hlavicka.sirka - 1 + dop do 
      begin 
        if not eof(BMPsoubor) then {Nektere soubory mohou byt poskozene} 
        begin                      {nebo ja mam chybu v algoritmu} 
          {$i-} 
          if hlavicka.bits = 1 then 
            if j = 0 then blockread(BMPsoubor, pix, sizeof(pix)); 
          if hlavicka.bits = 4 then 
            if j = 0 then blockread(BMPsoubor, pix, sizeof(pix)); 
          if hlavicka.bits = 8 then blockread(BMPsoubor, pix, sizeof(pix)); 
          if hlavicka.bits = 24 then blockread(BMPsoubor, pixbgr, sizeof(pixbgr)); 
          {$i+} 
        end;
        if ioresult <> 0 then 
        begin 
          closegraph; 
          writeln('Chyba pri nacitani souborovych dat.'); 
          halt; 
        end;
        if (y < 480) and (x < 640) and (x >= 0) and (y >= 0) then 
        begin 
          if hlavicka.bits = 1 then 
          begin 
            if pix and prizn[j] > 0 then putpixel(sx + x, sy - y, 1) 
            else putpixel(sx + x, sy - y, 0); 
            j := j + 1; 
            if j = 8 then j := 0; 
          end;
          if hlavicka.bits = 4 then 
          begin 
            if j = 0 then pix16 := pix shr 4 
            else 
            begin 
              pix16 := pix shl 4; 
              pix16 := pix16 shr 4; 
            end; 
            putpixel(sx + x, sy - y, pix16); 
            j := j + 1; 
            if j = 2 then j := 0; 
          end;
          if hlavicka.bits = 8 then putpixel(sx + x, sy - y, pix);
          if hlavicka.bits = 24 then putpixel(sx + x, sy - y, pixbgr.red shr 5 + 
             ((pixbgr.green shr 5) shl 3) + (pixbgr.blue and 192));
        end; 
      end; 
    close(BMPsoubor); 
    repeat until keypressed; 
    klav := readkey; 
    if klav = #27 then break; 
    if klav = #0 then klav := readkey; 
  end; 
  closegraph; 
  writeln('Filip Louzecky, 2008'); 
end.