{$M 4096, 0, 0}
{$i-}

(****************************************************************************
 * SPOUSTEC: Tento program podle nastaveni v konfiguracnim souboru umoznuje *
 *           spoustet vybrane programy z prehledne textove nabidky.         *
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
 * Copyright (C) 2009 Filip Louzecky                                        *
 * License GPLv3+: GNU GPL version 3 or later                               *
 *  <http://gnu.org/licenses/>.                                             *
 * This is free software: you are free to change and redistribute it.       *
 * There is NO WARRANTY, to the extent permitted by law.                    *
 *                                                                          *
 * Author's website and e-mail:                                             *
 * <http://hamsoft.wz.cz/>, <louzeckyfilip@seznam.cz>                       *
 ****************************************************************************)

program Spoustec;
uses
  crt, dos;

const
  soubor: string = 'SPOUSTEC.CFG'; (* Nazev konfiguracniho souboru. *)
  pocet = 100; (* Maximalni pocet zaznamu. *)
  adr_poc = 255; (* Maximalni pocet znaku cesty k programu. *)
  sou_poc = 12; (* Maximalni pocet znaku v nazvu souboru. *)
  naz_poc = 30; (* Maximalni pocet znaku v zobrazenem nazvu. *)
  obr_y = 22; (* Rozmery obrazku. *)
  obr_x = 40;
  radky   = 18; (* Pocet radku s nazvy programu. *)
  (* Pokud je pred nasledujicimi znaky libovolny jiny znak (krome mezer, ty
     se oriznou), tak ztraci tuto svou specialni funkci. *)
  kom   : char = ';'; (* Znak pro komentar, pokud timto znakem zacina radek
                         v konfiguracnim souboru, je ignorovan. *)
  obr   : char = '='; (* Znak pro obrazek, pokud timto znakem zacina radek
                         v konfiguracnim souboru, bude vypsan vpravo vedle
                         menu. *)
  bar   : char = '%'; (* Znak pro radek s nastavenim barev, je jich zde celkem
                         pet: popredi, pozadi, ram, aktivni popredi a aktivni
                         pozadi. *)
  bar_1 : byte = yellow; (* Zluta *)
  bar_2 : byte = blue; (* Modra *)
  bar_3 : byte = lightblue; (* Svetle modra *)
  bar_4 : byte = blue; (* Modra *)
  bar_5 : byte = lightgray; (* Svetle seda *)
  doserr: array[2..18] of string = ('Soubor nenalezen.', 'Nenalezena cesta.',
                                  '?', 'Zakazany pristup.',
                                  'Neplatny deskriptor souboru.', '?',
                                  'Nedostatek pameti.', '?',
                                  'Neplatne prostredi.', 'Neplatny format.',
                                  '?', '?', '?', '?', '?', '?',
                                  'Dalsi soubory nenalezeny.');

type
  zaznam = record
             adresar: string[adr_poc];
             soubor : string[sou_poc];
             nazev  : string[naz_poc];
           end;

var
  f                   : text; (* Textovy soubor obsahujici programy, jejich
                                 nazvy apod. *)
  s                   : string;
  i, clkm, vrsek, obr_r,
  vybr                : byte;
  pole                : array[1..pocet] of zaznam;
  adr, akt_adr        : string;
  obrm                : array[1..obr_y, 1..obr_x] of char;
                        (* Dvourozmerna matice: [radky, sloupce]! *)
  klav                : char;

function trim(s: string): string;
var (* Tato fce odstrani ze zacatku a z konce retezce mezery. *)
  i           : byte;
  poms1, poms2: string;
  nemez       : boolean;
begin
  if length(s) > 0 then
  begin
    poms1 := '';
    poms2 := '';
    nemez := false;
    for i := 1 to length(s) do
      if (s[i] <> ' ') or nemez then
      begin (* Odmazeme mezery zepredu. *)
        poms1 := poms1 + s[i];
        nemez := true;
      end;
    nemez := false;
    if length(poms1) > 0 then
      for i := length(poms1) downto 1 do
        if (poms1[i] <> ' ') or nemez then
        begin (* Odmazeme mezery zezadu (pozor, pri tomto se retez obrati). *)
          poms2 := poms2 + poms1[i];
          nemez := true;
        end;
    poms1 := ''; (* A zde se retezec zase obrati nazpet... *)
    for i := length(poms2) downto 1 do
      poms1 := poms1 + poms2[i];
    trim := poms1; (* A vysledek predame vyse... *)
  end
  else
    trim := s;
end;

procedure pridejzaznam(s: string);
var (* Tato procedura do promenne pole prida novy zaznam ziskany z udaju
       z nacteneho souboroveho radku. *)
  j, poc: byte;
begin
  if length(s) > 0 then
  begin
    poc := 1;
    for j := 1 to length(s) do
    begin (* Projdeme si cely nacteny radek... *)
      if poc = 1 then
      begin (* Do prvni mezery budeme vse povazovat za adresar... *)
        if s[j] = ' ' then
          inc(poc)
        else if j <= adr_poc then (* Snad ten string nepretece... *)
          pole[clkm].adresar := pole[clkm].adresar + s[j];
      end
      else if poc = 2 then
      begin (* Od prvni do druhe mezery budeme vse povazovat za soubor. *)
        if s[j] = ' ' then
          inc(poc)
        else if j - 1 - length(pole[clkm].adresar)  <= sou_poc then
          (* Tady snad take ne. *)
          pole[clkm].soubor := pole[clkm].soubor + s[j];
      end
      else if poc = 3 then
      begin (* A od druhe mezery dale budeme vse povazovat za nazev (i to, co
               nasleduje za dalsimi mezerami). *)
        if j - 2 - length(pole[clkm].adresar) - length(pole[clkm].soubor)
          <= naz_poc then (* A do tretice vseho dobreho (snad)... *)
          pole[clkm].nazev := pole[clkm].nazev + s[j];
      end;
      if poc > 3 then
        break; (* Proc zbytecne prochazet cyklus, kdyz uz vse mame? *)
    end;
  end;
end;

procedure pridejobr(s: string);
var (* Tato procedura ulozi radek textu do radku matice znaku. *)
  j: byte;
begin
  if length(s) > 1 then
    for j := 2 to length(s) do
      if (j - 1 <= obr_x) and (i <= obr_y) then
        obrm[i, j - 1] := s[j];
end;

procedure nastavbarvy(s: string);
var (* Tato procedura se pokusi z nactenych udaju vycucat barvy :) *)
  i, poc                  : byte;
  poms, s1, s2, s3, s4, s5: string;
  chyba                   : integer;
begin
  s1 := ''; s2 := ''; s3 := ''; s4 := ''; s5 := '';
  poc := 1;
  if length(s) > 1 then
  begin
    for i := 2 to length(s) do
    begin
      if s[i] = ' ' then
        inc(poc)
      else
      begin
        if poc = 1 then
          s1 := s1 + s[i]
        else if poc = 2 then
          s2 := s2 + s[i]
        else if poc = 3 then
          s3 := s3 + s[i]
        else if poc = 4 then
          s4 := s4 + s[i]
        else if poc = 5 then
          s5 := s5 + s[i]
        else
          break; (* Dalsi znaky v tomto radku me uz doopravdy nezajimaji. *)
      end;
    end;
    poc := 32;
    i := 32;
    if s1 <> s2 then
    begin
      val(s1, i, chyba);
      if chyba = 0 then
        poc := i;
      val(s2, i, chyba);
      if (chyba = 0) and (i <> poc) then
      begin
        bar_1 := poc;
        bar_2 := i;
      end;
    end;
    val(s3, poc, chyba);
    if chyba = 0 then
      bar_3 := poc;
    poc := 32;
    i := 32;
    if s4 <> s5 then
    begin
      val(s4, i, chyba);
      if chyba = 0 then
        poc := i;
      val(s5, i, chyba);
      if (chyba = 0) and (i <> poc) then
      begin
        bar_4 := poc;
        bar_5 := i;
      end;
    end;
  end;
end;

procedure getmydir(var adr: string);
var (* Tato procedura zjisti adresar programu (tohoto!), ve kterem se
       nachazi, doufam, ze to bude fungovat i v pripade, ze nekdo adresar
       tohoto programu prida do promenne path... *)
  i: byte;
begin
  adr := paramstr(0); (* ParamStr(0) obsahuje adresar a nazev tohoto
                         programu. *)
  for i := length(adr) downto 1 do
    if adr[i] = '\' then
      break;
  delete(adr, i + 1, length(adr) - i);
end;

procedure nabidka;
var (* Tato procedura se postara o vykresleni menu, je prece zbytecne
       vykreslovat kvuli podbarveni textu celou obrazovku... *)
  i, j: byte;
begin
  textcolor(bar_3);
  textbackground(bar_2);
  for i := 5 to radky + 2 do
  begin
    gotoxy(naz_poc + 6, i);
    write(chr(176));
  end;
  gotoxy(naz_poc + 6, 4); write(chr(30));
  gotoxy(naz_poc + 6, radky + 3); write(chr(31));
  if clkm = 0 then
  begin
    textcolor(bar_1);
    textbackground(bar_2);
    gotoxy(6, 4);
    write('V konfiguracnim souboru nejsou');
    gotoxy(6, 5);
    write('uvedeny zadne programy.');
    normvideo;
    gotoxy(1, 25);
    exit;
  end;
  if vybr > clkm then
    vybr := 1;
  if vrsek > clkm then
    vrsek := 1;
  if (vybr > vrsek) and (vybr - vrsek >= radky) then
    inc(vrsek);
  if vybr < vrsek then
    dec(vrsek);
  for j := 1 to radky do
  begin
    if j > clkm then break;
    if j + vrsek - 1 = vybr then
    begin
      textcolor(bar_4);
      textbackground(bar_5);
    end
    else
    begin
      textcolor(bar_1);
      textbackground(bar_2);
    end;
    gotoxy(6, 3 + j); write(pole[j + vrsek - 1].nazev);
    if length(pole[j + vrsek - 1].nazev) < naz_poc then
      for i := length(pole[j + vrsek - 1].nazev) + 1 to naz_poc do
        write(' ');
  end;
  textcolor(bar_3);
  textbackground(bar_2);
  if clkm > radky then
  begin
    gotoxy(naz_poc + 6, 5 + trunc(vybr / clkm * (radky - 3)));
    write(chr(2));
  end;
  gotoxy(1, 25);
  normvideo;
  (*gotoxy(1, 25); write('Vrsek: ', vrsek:3, ', Vybr: ', vybr:3,
                       ', Adr.: ', pole[vybr].adresar:20, ', Soub.: ',
                       pole[vybr].soubor:13);*)
end;

procedure vykresli;
var (* Tato procedura se postara o vykresleni vseho na obrazovku. *)
  i, j: byte;
begin
  textbackground(bar_2);
  textcolor(bar_3);
  for i := 2 to 79 do
  begin
    gotoxy(i, 1); write(chr(205));
    gotoxy(i, 24); write(chr(205));
  end;
  for i := 2 to 23 do
  begin
    gotoxy(1, i); write(chr(186));
    gotoxy(80, i); write(chr(186));
  end;
  gotoxy(1, 1); write(chr(201));
  gotoxy(1, 24); write(chr(200));
  gotoxy(80, 1); write(chr(187));
  gotoxy(80, 24); write(chr(188));
  for j := 2 to 23 do
    for i := 2 to 79 do
    begin
      gotoxy(i, j);
      write(' ');
    end;
  for i := 1 to obr_y do
    for j := 1 to obr_x do
    begin
      gotoxy(79 - obr_x + j, i + 1);
      write(obrm[i, j]);
    end;
  for i := 6 to naz_poc + 5 do
  begin
    gotoxy(i, 3); write(chr(196));
    gotoxy(i, radky + 4); write(chr(196));
  end;
  for i := 4 to radky + 3 do
  begin
    gotoxy(5, i);
    write(chr(179));
  end;
  gotoxy(5, 3); write(chr(218));
  gotoxy(naz_poc + 6, 3); write(chr(191));
  gotoxy(5, radky + 4); write(chr(192));
  gotoxy(naz_poc + 6, radky + 4); write(chr(217));
  textcolor(bar_1);
  gotoxy(5 + naz_poc div 2 - 10, 2);
  write('Seznam programu (her)');
  gotoxy(5 + naz_poc div 2 - 13, 23);
  write(#24#25'...posun, Enter...spustit');
  gotoxy(1, 25);
  normvideo;
end;

procedure dialog_okenko(titulek, zprava: string);
var (* Tato procedura je zde pouze proto, ze jeji kod by se opakoval na dvou
       mistech. *)
  i, j: byte;
begin
  textcolor(bar_3);
  textbackground(bar_2);
  for i := 1 to 80 do
  begin
    gotoxy(i, 5);
    write(chr(205));
    gotoxy(i, 13);
    write(chr(205));
  end;
  for j := 6 to 12 do
    for i := 1 to 80 do
    begin
      gotoxy(i, j);
      write(' ');
    end;
  textcolor(bar_1);
  gotoxy(40 - length(titulek) div 2 - 1, 5);
  write(' ', titulek, ' ');
  gotoxy(2, 7);
  write(zprava);
end;

procedure zprava(titulek, zprava: string); (* Tato procedura se postara
                                              o vykresleni zpravy. *)
begin
  dialog_okenko(titulek, zprava);
  textcolor(bar_3);
  gotoxy(30, 12);
  write('Stisknete cokoliv...');
  klav := readkey;
  if klav = #0 then
    klav := readkey;
  vykresli;
  nabidka;
end;

procedure vstup(titulek, zprava: string; var ret: string); (* Tato procedura
                               se postara o vykresleni vstupniho dialogu. *)
begin
  dialog_okenko(titulek, zprava);
  ret := '';
  readln(ret);
  vykresli;
  nabidka;
end;

function koncinabat(ret: string): boolean;
var (* Tato funkce vrati true, pokud parametr konci na BAT. *)
  i: byte;
  s: string;
begin
  s := '';
  if length(ret) > 2 then
    for i := length(ret) - 2 to length(ret) do
      s := s + upcase(ret[i]);
  if s = 'BAT' then
    koncinabat := true
  else
    koncinabat := false;
end;

begin
  for i := 1 to pocet do
  begin
    pole[i].adresar := '';
    pole[i].soubor := '';
    pole[i].nazev := '';
  end;
  for vrsek := 1 to obr_y do
    for i := 1 to obr_x do
      obrm[vrsek, i] := ' ';
  vrsek := 1;
  vybr := 1;
  getmydir(adr); (* Zjisteni adresare tohoto programu, bude se hodit nejen
                    pro nacteni konfiguracniho souboru. *)
  getdir(0, akt_adr); (* Zjisteni aktualniho adresare. *)
  assign(f, adr+soubor);
  reset(f); (* Zacatek nacitani konfiguracniho souboru. *)
  if ioresult <> 0 then
  begin (* Ajaj, objevila se tu nejaka chybka... *)
    writeln(chr(7), 'Pri nacitani souboru ', adr, soubor, ' doslo k chybe.');
    writeln;
    writeln('Nachazi se tento soubor ve stejne slozce, jako tento program?');
  end
  else
  begin
    clkm := 0;
    i := 0;
    while not eof(f) do
    begin
      s := '';
      readln(f, s); (* Nacteni radku, co se stane, jestlize radek v souboru
                       obsahuje vice znaku, nez se vejde do stringu? To stoji
                       za vyzkouseni, pokud si na to vzpomenu :) *)
      if ioresult <> 0 then
      begin
        writeln('Chyba pri nacitani dat z konfiguracniho souboru ', adr,
                soubor, '.');
        close(f);
        halt(1);
      end;
      s := trim(s); (* Mezery nepotrebuji. *)
      if length(s) > 0 then
      begin (* Pokud ma retezec alespon jeden znak, stoji za namahu. *)
        if (s[1] <> kom) and (s[1] <> obr) and (s[1] <> bar) and
          (clkm <= pocet) then
        begin
          inc(clkm);
          pridejzaznam(s); (* Pokud nezacina na vyse uvedene znaky a neni
                              prekrocen maximalni pocet zaznamu, tak to
                              ulozime do pole. *)
        end;
        if s[1] = obr then
        begin
          inc(i);
          pridejobr(s);
        end;
        if (s[1] = bar) and (i <= obr_y) then
          nastavbarvy(s);
      end;
    end;
    close(f); (* Nezapomenout na zavreni souboru! *)
    vykresli;
    repeat
      nabidka;
      klav := readkey;
      if klav = #0 then
        klav := readkey;
      if klav = #72 then (* Sipka nahoru. *)
        if vybr > 1 then
          dec(vybr);
      if klav = #80 then (* Sipka dolu. *)
        if vybr < clkm then
          inc(vybr);
      if ((klav = #13) or (klav = #32)) and (clkm <> 0) then
      (* Enter a mezernik. *)
      begin
        chdir(pole[vybr].adresar);
        if ioresult = 0 then
        begin
          if klav = #32 then (* Specialni blok pro mezernik. *)
            vstup('Parametry prikazove radky pro ' + pole[vybr].soubor,
                  'Zadejte parametry: ', s)
          else
            s := '';
          clrscr;
          if koncinabat(pole[vybr].soubor) then
          begin
            swapvectors;
            exec(getenv('COMSPEC'), '/C ' + pole[vybr].adresar + '\' +
                 pole[vybr].soubor);
            swapvectors;
          end
          else
          begin
            swapvectors;
            exec(pole[vybr].adresar + '\' + pole[vybr].soubor, s);
            swapvectors;
          end;
          if doserror <> 0 then
          begin
            str(doserror, s);
            zprava('Chyba DOSu!', 'Doslo k chybe DOSu #: ' + s + ' (' +
                   doserr[doserror] + ')');
          end
          else
          begin
            write('Stisknete cokoliv...');
            klav := readkey;
            if klav = #0 then
              klav := readkey;
          end;
          normvideo;
          clrscr;
          vykresli;
          nabidka;
          chdir(akt_adr);
        end
        else
        begin
          chdir(akt_adr);
          zprava('Chybna cesta k programu',
                 'Nelze se z aktualniho adresare ('+ akt_adr +
                 ') prepnout do adresare ');
        end;
      end;
    until klav = #27;
    clrscr;
    writeln('Tento program je svobodny software: muzete jej sirit a modifikovat podle');
    writeln('ustanoveni GNU General Public License, vydavane Free Software Foundation;');
    writeln('a to bud verze 3 teto licence anebo (podle vaseho uvazeni) kterekoli');
    writeln('pozdejsi verze.');
    writeln;
    writeln('Tento program je rozsirovan v nadeji, ze bude uzitecny, avsak BEZ JAKEKOLI');
    writeln('ZARUKY; neposkytuji se ani odvozene zaruky PRODEJNOSTI anebo VHODNOSTI');
    writeln('PRO URCITY UCEL. Dalsi podrobnosti hledejte v GNU General Public License.');
    writeln;
    writeln('Kopii GNU General Public License jste mel obdrzet spolu s timto programem;');
    writeln('pokud se tak nestalo, podivejte se na <http://www.gnu.org/licenses/>.');
    writeln;
    writeln('Kontakt na autora naleznete na <http://hamsoft.wz.cz/>.');
    writeln;
    writeln;
    writeln('Program ukoncen, uzijte si praci v radku :)');
  end;
end. (* Uff, konecne konec... Na to, jak malo to umi, to je nejak dlouhe :D *)